<?
/**
*    Codi clase Delete_helper.php
*
*    @autor Jose Roig Torres
*
*    @tasca projecte de fi de carrera
*
*    @universitat Universitat Oberta de Catalunya
*
*    @area aplicacions web per treball col·laboratiu
*
*    @tema disseny i prototipatge d'un sistema d'esdeveniments per a dispositius mòbils de treball en grup
*/

//clase que contindra les variables de configuracio de la web
include_once('libraries/php/db_connection.php');
include_once('src/integration/i_grup.php');
include_once('src/integration/i_tasca_grup.php');
include_once('src/integration/i_tasca_usuari.php');
include_once('src/integration/i_usuari.php');
include_once('src/integration/i_usuari_usuari.php');
include_once('src/integration/i_usuari_grup.php');
include_once('src/integration/i_tasca.php');
include_once('src/integration/i_missatge.php');
include_once('src/integration/i_llegit.php');
include_once('src/integration/i_esdeveniment.php');
include_once('src/integration/i_esdeveniment_grup.php');
include_once('src/integration/i_esdeveniment_usuari.php');
include_once('src/integration/i_esdeveniment_tasca.php');
include_once('src/integration/i_info_usuari_tasca.php');

class Delete_helper {
	
	//variables de clase
	var $connect;
	
	//constructor
	function Delete_helper(){
		
		//creem la conexio
		$this->connect=new Db_connection();
		$this->connect->connect();
		
	}
	
	//funcio per esborrar un contacte
	function esborrar_contacte($id_usuari, $id_contacte){
		
		//borrem files corresponents usuari_usuari
		$query="DELETE FROM usuari_usuari WHERE usuari_usuari.id_usuari_principal='".$id_usuari."' AND usuari_usuari.id_usuari_contacte='".$id_contacte."'";
		$this->connect->set_query($query);
		$query="DELETE FROM usuari_usuari WHERE usuari_usuari.id_usuari_principal='".$id_contacte."' AND usuari_usuari.id_usuari_contacte='".$id_usuari."'";
		$this->connect->set_query($query);
		
		//cerquem els esdeveniments de lusuari per el contacte
		$query="SELECT esdeveniment_usuari.id_esdeveniment FROM esdeveniment, esdeveniment_usuari WHERE esdeveniment.id_usuari='".$id_usuari."' AND esdeveniment.id=esdeveniment_usuari.id_esdeveniment AND esdeveniment_usuari.id_usuari='".$id_contacte."'";
		$this->connect->set_query($query);
		$llista=$this->connect->get_object_list();
		
		//borrem files corresponents de esdeveniment_usuari
		$index=0;
		while($index < sizeof($llista)){
			
			$query="DELETE esdeveniment_usuari FROM esdeveniment_usuari WHERE esdeveniment_usuari.id_esdeveniment='".$llista[$index]->id_esdeveniment."'";
			$this->connect->set_query($query);
			
			$index=$index+1;
		}
		
		//realitzem recorregut per esdeveniments de la tasca
		$index=0;
		while($index < sizeof($llista)){
			
			//borrem esdeveniments en cas necessari
			$this->esborrar_esdeveniment($llista[$index]->id_esdeveniment);
			
			$index=$index+1;
		}
		
		//cerquem els missatges de lusuari
		$query="(SELECT missatge.id FROM missatge WHERE missatge.id_usuari_emisor='".$id_usuari."' AND missatge.id_usuari_receptor='".$id_contacte."')
		UNION
		(SELECT missatge.id FROM missatge WHERE missatge.id_usuari_emisor='".$id_contacte."' AND missatge.id_usuari_receptor='".$id_usuari."')
		";
		$this->connect->set_query($query);
		$llista=$this->connect->get_object_list();
		$index=0;
		while($index < sizeof($llista)){
			//recorrem els missatges per borrar les seves dades
			
			//esborrem missatge
			$this->esborrar_missatge($llista[$index]->id);
			
			$index=$index+1;
		}
		
	}
	
	//funcio per esborrar una tasca
	function esborrar_tasca($id_usuari, $id_tasca){
		
		$tasca_borrada=false;
		
		//marquem la tasca com eliminada
		$query="SELECT info_usuari_tasca.id FROM info_usuari_tasca WHERE info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_tasca='".$id_tasca."'";
		$this->connect->set_query($query);
		$llista=$this->connect->get_object_list();
		$index=0;
		
		while($index < sizeof($llista)){
			
			//posem latribut com eliminat
			$info_usuari_tasca=new I_info_usuari_tasca();
			$info_usuari_tasca->carregar_dades_per_id($llista[$index]->id);
			$info_usuari_tasca->id_estat=1;
			$info_usuari_tasca->guardar_dades();
			
			$index=$index+1;
		}
		
		//mirem si la tasca encara disposa de gent que la tingui
		$query="SELECT COUNT(info_usuari_tasca.id) as nombre FROM info_usuari_tasca WHERE  info_usuari_tasca.id_tasca='".$id_tasca."' AND info_usuari_tasca.id_estat!='1'";
		$this->connect->set_query($query);
		$llista=$this->connect->get_object_list();
		if($llista[0]->nombre==0){
			//tot els usuaris tenen la tasca com eliminada
			
			//borrem la tasca
			$query="DELETE FROM tasca WHERE tasca.id='".$id_tasca."'";
			$this->connect->set_query($query);
			
			//borrem les files de info_usuari_tasca
			$query="DELETE FROM info_usuari_tasca WHERE info_usuari_tasca.id_tasca='".$id_tasca."'";
			$this->connect->set_query($query);
			
			//cerquem els missatges de la tasca
			$query="SELECT missatge.id FROM missatge WHERE missatge.id_tasca='".$id_tasca."'";
			$this->connect->set_query($query);
			$llista=$this->connect->get_object_list();
			$index=0;
			while($index < sizeof($llista)){
				//recorrem els missatges per borrar les seves dades
				
				//esborrem missatge
				$this->esborrar_missatge($llista[$index]->id);
				
				$index=$index+1;
			}
			
			//borrem les files de tasca_grup
			$query="DELETE FROM tasca_grup WHERE tasca_grup.id_tasca='".$id_tasca."'";
			$this->connect->set_query($query);
			
			//borrem les files de tasca_usuari
			$query="DELETE FROM tasca_usuari WHERE tasca_usuari.id_tasca='".$id_tasca."'";
			$this->connect->set_query($query);
			
			//cerquem els esdeveniments de la tasca
			$query="SELECT esdeveniment_tasca.id_esdeveniment FROM esdeveniment_tasca WHERE esdeveniment_tasca.id_tasca='".$id_tasca."'";
			$this->connect->set_query($query);
			$llista=$this->connect->get_object_list();
			
			//borrem files de esdeveniment_tasca
			$query="DELETE FROM esdeveniment_tasca WHERE esdeveniment_tasca.id_tasca='".$id_tasca."'";
			$this->connect->set_query($query);
			
			//realitzem recorregut per esdeveniments de la tasca
			$index=0;
			while($index < sizeof($llista)){
				
				//borrem esdeveniments en cas necessari
				$this->esborrar_esdeveniment($llista[$index]->id_esdeveniment);
				
				$index=$index+1;
			}
			
			//actualitzem atribut tasca borrada
			$tasca_borrada=true;
			
		}else{
			
		}
		
		//mirem si la tasca ja ha sigut borrada
		if($tasca_borrada==false){
			//la tasca no ha sigut borrada
			
			//mirem si la tasca encara disposa d'enllaços de grup o de usuari
			$query="
			SELECT COUNT(*) AS nombre FROM 
			(
			SELECT tasca_grup.id FROM tasca_grup WHERE tasca_grup.id_tasca='".$id_tasca."'
			UNION ALL
			SELECT tasca_usuari.id FROM tasca_usuari WHERE tasca_usuari.id_tasca='".$id_tasca."'
			)AS taula
			";
			$this->connect->set_query($query);
			$llista=$this->connect->get_object_list();
			if($llista[0]->nombre==0){
				//la tasca no diposa d'ellaços ni a grups ni a usuaris
				
				//borrem la tasca
				$query="DELETE FROM tasca WHERE tasca.id='".$id_tasca."'";
				$this->connect->set_query($query);
				
				//borrem les files de info_usuari_tasca
				$query="DELETE FROM info_usuari_tasca WHERE info_usuari_tasca.id_tasca='".$id_tasca."'";
				$this->connect->set_query($query);
				
				//cerquem els missatges de la tasca
				$query="SELECT missatge.id FROM missatge WHERE missatge.id_tasca='".$id_tasca."'";
				$this->connect->set_query($query);
				$llista=$this->connect->get_object_list();
				$index=0;
				while($index < sizeof($llista)){
					//recorrem els missatges per borrar les seves dades
					
					//esborrem missatge
					$this->esborrar_missatge($llista[$index]->id);
					
					$index=$index+1;
				}
				
				//borrem les files de tasca_grup
				$query="DELETE FROM tasca_grup WHERE tasca_grup.id_tasca='".$id_tasca."'";
				$this->connect->set_query($query);
				
				//borrem les files de tasca_usuari
				$query="DELETE FROM tasca_usuari WHERE tasca_usuari.id_tasca='".$id_tasca."'";
				$this->connect->set_query($query);
				
				//cerquem els esdeveniments de la tasca
				$query="SELECT esdeveniment_tasca.id_esdeveniment FROM esdeveniment_tasca WHERE esdeveniment_tasca.id_tasca='".$id_tasca."'";
				$this->connect->set_query($query);
				$llista=$this->connect->get_object_list();
				
				//borrem files de esdeveniment_tasca
				$query="DELETE FROM esdeveniment_tasca WHERE esdeveniment_tasca.id_tasca='".$id_tasca."'";
				$this->connect->set_query($query);
				
				//realitzem recorregut per esdeveniments de la tasca
				$index=0;
				while($index < sizeof($llista)){
					
					//borrem esdeveniments en cas necessari
					$this->esborrar_esdeveniment($llista[$index]->id_esdeveniment);
					
					$index=$index+1;
				}
				
			}else{
				//la tasca si disposa d'ellaços a grups o usuaris
				//no fem res
			}
			
		}else{
			//tasca ja ha sigut borrada
			//no fem res
		}
		
	}
	
	//funcio per esborrar un grup
	function esborrar_grup($id_usuari, $id_grup){

		//borrem la fila de usuari_grup
		$query="DELETE FROM usuari_grup WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup='".$id_grup."'";
		$this->connect->set_query($query);
		
		//mirem si el grup te tasques per tal de poner marcarles com que lusuari las ha eliminat
		$query="SELECT info_usuari_tasca.id FROM info_usuari_tasca, tasca_grup WHERE tasca_grup.id_grup='".$id_grup."' AND info_usuari_tasca.id_tasca=tasca_grup.id_tasca AND info_usuari_tasca.id_usuari='".$id_usuari."'";
		$this->connect->set_query($query);
		$llista=$this->connect->get_object_list();
		$index=0;
		while($index < sizeof($llista)){
			
			$info_usuari_tasca=new I_info_usuari_tasca();
			$info_usuari_tasca->carregar_dades_per_id($llista[$index]->id);
			//marquem la tasca com eliminada
			$info_usuari_tasca->id_estat=1;
			$info_usuari_tasca->guardar_dades();
			
			$index=$index+1;
		}
		
		//comprovem si el grup encara te usuaris
		$query="SELECT COUNT(DISTINCT usuari_grup.id) AS nombre FROM usuari_grup WHERE usuari_grup.id_grup='".$id_grup."'";
		$this->connect->set_query($query);
		$llista=$this->connect->get_object_list();
		if($llista[0]->nombre==0){
			//el grup no disposa dusuaris
			
			//borrem el grup
			$query="DELETE FROM grup WHERE grup.id='".$id_grup."'";
			$this->connect->set_query($query);
			
			//cerquem els missatges del grup
			$query="SELECT missatge.id FROM missatge WHERE missatge.id_grup='".$id_grup."'";
			$this->connect->set_query($query);
			$llista=$this->connect->get_object_list();
			$index=0;
			while($index < sizeof($llista)){
				//recorrem els missatges per borrar les seves dades
				
				//esborrem missatge
				$this->esborrar_missatge($llista[$index]->id);
				
				$index=$index+1;
			}
			
			//obtenim els esdeveniments de grup
			$query="SELECT esdeveniment_grup.id_esdeveniment FROM esdeveniment_grup WHERE esdeveniment_grup.id_grup='".$id_grup."'";
			$this->connect->set_query($query);
			$llista=$this->connect->get_object_list();
			
			//borrem les entrades de esdeveniment_grup
			$query="DELETE FROM esdeveniment_grup WHERE esdeveniment_grup.id_grup='".$id_grup."'";
			$this->connect->set_query($query);
			
			//realitzem recorregut per els esdeveniment del grup
			$index=0;
			while($index < sizeof($llista)){
				
				//borrem esdeveniment en cas necessari
				$this->esborrar_esdeveniment($llista[$index]->id_esdeveniment);
				
				$index=$index+1;	
			}
			
			//obtenim les tasques que apuntaven al grup
			$query="SELECT tasca.id FROM tasca, tasca_grup WHERE tasca_grup.id_grup='".$id_grup."' AND tasca_grup.id_tasca=tasca.id";
			$this->connect->set_query($query);
			$llista=$this->connect->get_object_list();
			
			//borrem les entrades de tasca_grup del grup actual
			$index=0;
			while($index < sizeof($llista)){
			
				$query="DELETE FROM tasca_grup WHERE tasca_grup.id_grup='".$id_grup."' AND tasca_grup.id_tasca='".$llista[$index]->id."'";
				$this->connect->set_query($query);
			
				$index=$index+1;	
			}
			
			//realitzem recorregut per les tasques que apuntaven al grup
			$index=0;
			while($index < sizeof($llista)){
			
				//borrem tasca en cas necessari
				$this->esborrar_tasca($id_usuari, $llista[$index]->id);
			
				$index=$index+1;	
			}
			
		}else{
			//el grup encara te usuaris
			//no fem res
		}

	}
	
	//funcio per esborrar un missatge
	function esborrar_missatge($id_missatge){
		
		//obtenim dades del missatge
		$missatge=new I_missatge();
		$missatge->carregar_dades_per_id($id_missatge);
		//esborrem les files de taula llegit
		$query="DELETE FROM llegit WHERE llegit.id_missatge='".$id_missatge."'";
		$this->connect->set_query($query);
		//esborrem el missatge
		$query="DELETE FROM missatge WHERE missatge.id='".$id_missatge."'";
		$this->connect->set_query($query);
		
	}
	
	//funcio per esborrar un esdeveniment
	function esborrar_esdeveniment($id_esdeveniment){
		
		//obtenim els enllaços de lesdeveniment
		$query="
		SELECT COUNT(*) AS nombre FROM 
		(
		SELECT esdeveniment_grup.id_esdeveniment FROM esdeveniment_grup WHERE esdeveniment_grup.id_esdeveniment='".$id_esdeveniment."'
		UNION ALL
		SELECT esdeveniment_tasca.id_esdeveniment FROM esdeveniment_tasca WHERE esdeveniment_tasca.id_esdeveniment='".$id_esdeveniment."'
		UNION ALL
		SELECT esdeveniment_usuari.id_esdeveniment FROM esdeveniment_usuari WHERE esdeveniment_usuari.id_esdeveniment='".$id_esdeveniment."'
		)AS taula
		";
		$this->connect->set_query($query);
		$llista=$this->connect->get_object_list();
		
		//mirem si lesdeveniment encara te enllaços
		if($llista->nombre==0){
			//lesdeveniment no te enllaços
			
			//borrem lesdeveniment
			$query="DELETE FROM esdeveniment WHERE esdeveniment.id='".$id_esdeveniment."'";
			$this->connect->set_query($query);
			
		}else{
			//lesdeveniment encara te enllaços
			//no fem res
		}
		
	}
	
	
}
?>
