<?
/**
*    Codi clase B_contacte.php
*
*    @autor Jose Roig Torres
*
*    @tasca projecte de fi de carrera
*
*    @universitat Universitat Oberta de Catalunya
*
*    @area aplicacions web per treball col·laboratiu
*
*    @tema disseny i prototipatge d'un sistema d'esdeveniments per a dispositius mòbils de treball en grup
*/

include_once('libraries/php/db_connection.php');
include_once('src/integration/i_usuari.php');
include_once('src/integration/i_usuari_usuari.php');
include_once('src/integration/i_missatge.php');
include_once('src/integration/i_llegit.php');
include_once('src/integration/i_esdeveniment.php');
include_once('src/integration/i_esdeveniment_usuari.php');
include_once('libraries/php/calendar.php');
include_once('libraries/php/template_helper.php');
include_once('libraries/php/delete_helper.php');

class B_contacte {
	
	//variable de nok template
	var $html;
	
	//constructor
	function B_contacte($html){
		$this->html=$html;
	}
	
	//funcionalitat per vorer els contactes de lusuari actual
	function llista_contactes(){
		
		//obtenim els parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_contacte=$_REQUEST['id_contacte'];
		
		//creem la conexio
		$connect=new Db_connection();
		$connect->connect();
		
		//	carreguem els missatges nous
		include('includes/php/nombre_missatges_nous.php');
		
		//monetem la query
		$query="SELECT * FROM usuari_usuari WHERE id_usuari_principal='".$id_usuari."'";
		
		//obtenim els contactes
		$connect->set_query($query);
		$llista=$connect->get_object_list();

		//insertem dades en el template
		//	preparem les plantilles interiors
		$plantilla="p_llista_contactes_taula";
		$directori_plantilla="contacte/p_llista_contactes_taula.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_llista_contactes_fila', 'p_llista_contactes_taula');
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				// Obtenim lusuari actual
				$usuari=new I_usuari();
				$usuari->carregar_dades_per_id($llista[$index]->id_usuari_contacte);
				
				//borrem variables pk no hi hagi duplicidad de variables
				$this->html->limpiar("MISSATGES_NOUS_CONTACTES_LLISTA");
				
				// Asignam valors a la fila actual
				$this->html->asignar('USUARI', $usuari->usuari); 
				$this->html->asignar('ID_CONTACTE', $usuari->id);
				//		asignam el nombre de missatges no llegits de la fila actual
				$query="SELECT COUNT(DISTINCT llegit.id_missatge) AS nombre FROM llegit, missatge WHERE llegit.id_usuari='".$id_usuari."' AND llegit.id_missatge=missatge.id AND missatge.id_usuari_emisor='".$usuari->id."' AND missatge.id_usuari_receptor='".$id_usuari."'";
				
				$connect->set_query($query);
				$llista_aux=$connect->get_object_list();
				if($llista_aux[0]->nombre!=0){
					$this->html->asignar("MISSATGES_NOUS_CONTACTES_LLISTA","<span class='missatges_no_llegits'>".$llista_aux[0]->nombre."</span>");
				}
				
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES', '+p_llista_contactes_fila');
				}
				$index=$index+1;
			}
			$this->html->expandir('TAULA', 'p_llista_contactes_taula');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
	}
	
	//funcionalitat per vorer els contactes de lusuari actual
	function detall_contacte(){
		
		//obtenim els parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_contacte=$_REQUEST['id_contacte'];
		$contacte=new I_usuari();
		$contacte->carregar_dades_per_id($id_contacte);
		$nom_contacte=$contacte->usuari;
		
		//obtenim conexio
		$connect=new Db_connection();
		$connect->connect();
		
		//	preparem les plantilles interiors
		$plantilla="p_detall_contacte_missatges";
		$directori_plantilla="contacte/p_detall_contacte_missatges.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_detall_contacte_fila', 'p_detall_contacte_missatges');
		
		//  INSERIM DADES EN PLANTILLA PRINCIPAL
		$this->html->asignar('ID_CONTACTE', $id_contacte);
		$this->html->asignar('NOM_CONTACTE', $nom_contacte);
		
		//	INSERIM DADES DE LUSUARI
		$contacte=new I_usuari();
		$contacte->carregar_dades_per_id($id_contacte);
		$this->html->asignar('CONTACTE_USUARI', $contacte->usuari);
		$this->html->asignar('CONTACTE_NOM', $contacte->nom);
		$this->html->asignar('CONTACTE_LLINATGES', $contacte->llinatges);
		$this->html->asignar('CONTACTE_EMAIL', $contacte->email);
		
		//	CARREGUEM MISSATGES DEL CONTACTE
		$query="SELECT id, id_usuari_emisor FROM missatge WHERE (id_usuari_receptor='".$id_contacte."' AND id_usuari_emisor='".$id_usuari."') OR (id_usuari_receptor='".$id_usuari."' AND id_usuari_emisor='".$id_contacte."') ORDER BY missatge.data_hora";
		
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el missatge
				$missatge=new I_missatge();
				$missatge->carregar_dades_per_id($llista[$index]->id);
				
				//obtenim lusuari
				$usuari=new I_usuari();
				$usuari->carregar_dades_per_id($llista[$index]->id_usuari_emisor);
				
				// Asignam valors a la fila actual
				if($usuari->id==$id_usuari){
					$this->html->asignar('ROL_EMISOR', "usuari_lector"); 
				}else{
					$this->html->asignar('ROL_EMISOR', "usuari_no_lector");
				}
				$this->html->asignar('USUARI', $usuari->usuari); 
				$this->html->asignar('TEXT', $missatge->missatge);
				$data = new DateTime($missatge->data_hora);
				$data->format('Y-m-d H:i:s');
				$this->html->asignar('DATA', $data->format('Y-m-d')); 
				$this->html->asignar('HORA', $data->format('H:i:s'));  
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES', '+p_detall_contacte_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('MISSATGES', 'p_detall_contacte_missatges');
			
			//borram els apuntadors a missatges no llegits
			$query="DELETE llegit FROM llegit, missatge WHERE llegit.id_usuari='".$id_usuari."' AND llegit.id_missatge=missatge.id AND missatge.id_usuari_emisor='".$id_contacte."'";
			$connect->set_query($query);
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
		//	CARREGUEM ELS MISSATGES NOUS
		include('includes/php/nombre_missatges_nous.php');
		
		//	CARREGUEM ESDEVENIMENTS DEL CONTACTE 
		
		//	montem la query
		$query="SELECT * FROM (
		(SELECT esdeveniment.* FROM esdeveniment, esdeveniment_usuari WHERE
		esdeveniment.id_usuari='".$id_contacte."' AND esdeveniment.id=esdeveniment_usuari.id_esdeveniment AND esdeveniment_usuari.id_usuari='".$id_usuari."')
		UNION
		(SELECT esdeveniment.* FROM esdeveniment, esdeveniment_usuari WHERE
		esdeveniment.id_usuari='".$id_usuari."' AND esdeveniment.id=esdeveniment_usuari.id_esdeveniment AND esdeveniment_usuari.id_usuari='".$id_contacte."'
                )
		) AS taula
        ORDER BY taula.data_esdeveniment
		";
		
		//	obtenim els esdeveniments
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		
		//	preparem plantilla dels esdeveniments nous
		$plantilla="p_detall_contacte_esdeveniments";
		$directori_plantilla="contacte/p_detall_contacte_esdeveniments.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_detall_contacte_esdeveniments_fila', 'p_detall_contacte_esdeveniments');
		
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el esdeveniment
				$esdeveniment=new I_esdeveniment();
				$esdeveniment->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_ESDEVENIMENT', $esdeveniment->nom); 
				$this->html->asignar('ID_ESDEVENIMENT', $esdeveniment->id);
				$this->html->asignar('DATA_CREACIO_ESDEVENIMENT', $esdeveniment->data_creacio);
				$this->html->asignar('DATA_ESDEVENIMENT', $esdeveniment->data_esdeveniment);
				$this->html->asignar('DESCRIPCIO_ESDEVENIMENT', $esdeveniment->descripcio);
				
				//		obtenim el destinataris de l'esdeveniment
				include('includes/php/destinataris_esdeveniment.php');
				
				//			asignem destinataris de lesdeveniment
				$this->html->asignar('DESTINATARIS_ESDEVENIMENT', $destinataris);

				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES_ESDEVENIMENTS', '+p_detall_contacte_esdeveniments_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('ESDEVENIMENTS', 'p_detall_contacte_esdeveniments');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
		
	}
	
	//funcionalitat per afegir missatges el foro del grup
	function afegir_missatge_contacte(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$mis=$_REQUEST["missatge"];
		$id_contacte=$_REQUEST['id_contacte'];
		
		//inserim nou missatge
		$missatge=new I_missatge();
		$missatge->missatge=$mis;
		$missatge->id_usuari_emisor=$id_usuari;
		$missatge->id_usuari_receptor=$id_contacte;
		$data = new DateTime();
		$missatge->data_hora=$data->format('Y-m-d H:i:s');
		$id_missatge=$missatge->guardar_dades();
		
		//inserim files per marcar el missatge com a no llegit
		$llegit=new I_llegit();
		$llegit->id_usuari=$id_contacte;
		$llegit->id_missatge=$id_missatge;
		$llegit->llegit=0;
		$llegit->guardar_dades();
		
		//redireccionem
		header('Location: index.php?tasca=contacte.detall_contacte&plantilla=contacte.p_detall_contacte&id_contacte='.$id_contacte);
		
	}
	
	//funcionalitat per afegir esdeveniments per el contacte
	function afegir_esdeveniment_contacte(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_contacte=$_REQUEST['id_contacte'];
		$nom=$_REQUEST["nom"];
		$descripcio=$_REQUEST["descripcio"];
		$data=$_REQUEST["data"];
		
		//inserim nou esdeveniment
		$esdeveniment=new I_esdeveniment();
		$esdeveniment->nom=$nom;
		$esdeveniment->descripcio=$descripcio;
		$data_objecte = new DateTime($data);	
		$esdeveniment->data_esdeveniment=$data_objecte->format('Y-m-d');
		$data_objecte = new DateTime();	
		$esdeveniment->data_creacio=$data_objecte->format('Y-m-d');
		$esdeveniment->id_usuari=$id_usuari;	
		$id_esdeveniment=$esdeveniment->guardar_dades();
		
		//	inserim relacio amb el contacte
		$esdeveniment_usuari=new I_esdeveniment_usuari();
		$esdeveniment_usuari->id_usuari=$id_contacte;
		$esdeveniment_usuari->id_esdeveniment=$id_esdeveniment;
		$esdeveniment_usuari->guardar_dades();
	
		//	inserim relacio de usuari principal
		$esdeveniment_usuari=new I_esdeveniment_usuari();
		$esdeveniment_usuari->id_usuari=$id_usuari;
		$esdeveniment_usuari->id_esdeveniment=$id_esdeveniment;
		$esdeveniment_usuari->guardar_dades();
		
		//redireccionem
		header('Location: index.php?tasca=contacte.detall_contacte&plantilla=contacte.p_detall_contacte&id_contacte='.$id_contacte);
		
	}
	
	//funcionalitat per carregar les dades necessaries per afegir un grup
	function dades_afegir_esdeveniment_contacte(){
		
		//obtenim conexion a la base de dades
		$connect=new Db_connection();
		$connect->connect();
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_contacte=$_REQUEST["id_contacte"];
		
		//carreguem dades de la plantilla
		$this->html->asignar('ID_CONTACTE', $id_contacte);
		
		//	carreguem els missatges nous
		include('includes/php/nombre_missatges_nous.php');
		
	}
	
	//funcionalitat per afegir contactes usuari
	function afegir_contacte(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_contacte=$_REQUEST["id_contacte"];
		
		//inserim nou contacte
		$us_us=new I_usuari_usuari();
		$us_us->id_usuari_principal=$id_usuari;
		$us_us->id_usuari_contacte=$id_contacte;
		$us_us->guardar_dades();
		$us_us->id_usuari_principal=$id_contacte;
		$us_us->id_usuari_contacte=$id_usuari;
		$us_us->guardar_dades();
		
		//redireccionem
		header('Location: index.php?tasca=contacte.llista_contactes&plantilla=contacte.p_llista_contactes');
		
	}
	
	//funcionalitat per afegir contactes usuari
	function borrar_contacte(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_contacte=$_REQUEST['id_contacte'];
		
		//borrem el contacte
		$delete_helper=new Delete_helper();
		$delete_helper->esborrar_contacte($id_usuari, $id_contacte);
		
		//redireccionem
		header('Location: index.php?tasca=contacte.llista_contactes&plantilla=contacte.p_llista_contactes');
		
	}
	
	//funcionalitat per buscar usuaris
	function cercar_contacte(){
		
		//obtenim els parametres de cerca
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$nom=$_POST["nom"];
		$llinatges=$_POST["llinatges"];
		$usuari=$_POST["usuari"];
		$email=$_POST["email"];
		$cercar=false;
		
		//creem la conexio
		$connect=new Db_connection();
		$connect->connect();
		
		//	carreguem els missatges nous
		include('includes/php/nombre_missatges_nous.php');
		
		//construim la consulta
		$where="WHERE";
		if($nom!=""){
			$where=$where." usuari.nom LIKE '%".$nom."%'";
			$cercar=true;
		}
		if($llinatges!=""){
			if($where!="WHERE"){
				$where=$where." AND usuari.llinatges LIKE '%".$llinatges."%'";
			}else{
				$where=$where." usuari.llinatges LIKE '%".$llinatges."%'";
			}
			$cercar=true;
		}
		if($usuari!=""){
			if($where!="WHERE"){
				$where=$where." AND usuari.usuari LIKE '%".$usuari."%'";
			}else{
				$where=$where." usuari.usuari LIKE '%".$usuari."%'";
			}
			$cercar=true;
		}
		if($email!=""){
			if($where!="WHERE"){
				$where=$where." AND usuari.email LIKE '%".$email."%'";
			}else{
				$where=$where." usuari.email LIKE '%".$email."%'";
			}
			$cercar=true;
		}
		
		//si hi ha alguana dada de cerca al formulari
		if(	$cercar==true){
		
			//filtrem els que ja son contactes i el propi usuari
			if($where!="WHERE"){
				$where=$where." AND usuari.id!='".$id_usuari."' AND usuari.id NOT IN (SELECT usuari_usuari.id_usuari_contacte FROM usuari_usuari WHERE usuari_usuari.id_usuari_principal='".$id_usuari."')";
			}else{
				$where=$where." usuari.id!='".$id_usuari."' AND usuari.id NOT IN (SELECT usuari_usuari.id_usuari_contacte FROM usuari_usuari WHERE usuari_usuari.id_usuari_principal='".$id_usuari."')";
			}
			
			//montem where en cas necessari
			if($where!="WHERE"){
				$query="SELECT usuari.id, usuari.usuari, usuari.contrasenya, usuari.nom, usuari.llinatges, usuari.email FROM usuari ".$where;
			}else{
				$query="SELECT usuari.id, usuari.usuari, usuari.contrasenya, usuari.nom, usuari.llinatges, usuari.email FROM usuari ";
			}
			
			//busquem els usuaris segons el criteris de cerca
			if($query!="SELECT * FROM usuari "){
				$connect->set_query($query);
				$llista=$connect->get_object_list();
			}
	
			//insertem dades en el template
			//	preparem les plantilles interiors
			$plantilla="p_cercar_contacte_taula";
			$directori_plantilla="contacte/p_cercar_contacte_taula.html";
			$this->html->cargar($plantilla,$directori_plantilla);
			$this->html->definirBloque('p_cercar_contacte_fila', 'p_cercar_contacte_taula');
			//	recorrem array de dades per inserirles
			if(sizeof($llista)>0){
				
				$index=0;
				while($index < sizeof($llista)){
					// Asignam valors a la fila actual
					$this->html->asignar('NOM', $llista[$index]->nom); 
					$this->html->asignar('LLINATGES', $llista[$index]->llinatges);
					$this->html->asignar('EMAIL', $llista[$index]->email);  
					$this->html->asignar('USUARI', $llista[$index]->usuari); 
					$this->html->asignar('ID_CONTACTE', $llista[$index]->id);
					// Expandim la fila actual
					if($index!=(sizeof($llista)-1)){
						$this->html->expandir('FILES', '+p_cercar_contacte_fila');
					}
					$index=$index+1;
				}
				$this->html->expandir('TAULA', 'p_cercar_contacte_taula');
				
			}else{
				//lista sin objetos, no mostramos nada
			}
			
		}
		
	}
	
	
}
?>
