<?
/**
*    Codi clase B_esdeveniment.php
*
*    @autor Jose Roig Torres
*
*    @tasca projecte de fi de carrera
*
*    @universitat Universitat Oberta de Catalunya
*
*    @area aplicacions web per treball col·laboratiu
*
*    @tema disseny i prototipatge d'un sistema d'esdeveniments per a dispositius mòbils de treball en grup
*/

include_once('libraries/php/db_connection.php');
include_once('src/integration/i_grup.php');
include_once('src/integration/i_usuari.php');
include_once('src/integration/i_missatge.php');
include_once('src/integration/i_tasca.php');
include_once('src/integration/i_esdeveniment.php');
include_once('src/integration/i_tasca_grup.php');
include_once('src/integration/i_llegit.php');
include_once('src/integration/i_prioritat.php');
include_once('src/integration/i_usuari_grup.php');
include_once('src/integration/i_esdeveniment_usuari.php');
include_once('src/integration/i_esdeveniment_grup.php');
include_once('src/integration/i_esdeveniment_tasca.php');

class B_esdeveniment {
	
	//variable de nok template
	var $html;
	
	//constructor
	function B_esdeveniment($html){
		$this->html=$html;
	}
	
	//funcionalitat per vorer els esdeveniments de lusuari actual per el dia seleccionat
	function llista_esdeveniments(){
		
		//	CARREGUEM DADES PRINCIPALS ///////////////////////////////////
		$data_esdeveniments="";
		$data_esdeveniments=$data_esdeveniments.$_REQUEST["any"]."-".$_REQUEST["mes"]."-".$_REQUEST["dia"];
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$us=new I_usuari();
		$us->carregar_dades_per_id($_SESSION['id_usuari']);
		$this->html->asignar("DIA", $_REQUEST["dia"]."-".$_REQUEST["mes"]."-".$_REQUEST["any"]);
		
		//obtenim la conexio a la base de dades
		$connect=new Db_connection();
		$connect->connect();
		
		//	CARREGUEM MISSATGES NOUS ///////////////////////////////////
		include('includes/php/nombre_missatges_nous.php');
		
		//	CARREGUEM ESDEVENIMENTS DEL DIA ///////////////////////////////////
		
		//	montem la query
		$query="SELECT * FROM 
		(
		   (SELECT esdeveniment.* FROM esdeveniment, esdeveniment_usuari WHERE esdeveniment_usuari.id_usuari='".$id_usuari."' AND esdeveniment.id=esdeveniment_usuari.id_esdeveniment)
		UNION ALL
		   (SELECT esdeveniment.* FROM esdeveniment, esdeveniment_grup, usuari_grup WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=esdeveniment_grup.id_grup AND esdeveniment.id=esdeveniment_grup.id_esdeveniment)
		UNION ALL
		   (
		      (SELECT esdeveniment.* FROM esdeveniment, esdeveniment_tasca, usuari_grup, tasca_grup WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=tasca_grup.id_grup AND tasca_grup.id_tasca=esdeveniment_tasca.id_tasca AND esdeveniment.id=esdeveniment_tasca.id_esdeveniment)
		   )
		 UNION
		   (
		   	   (SELECT esdeveniment.* FROM esdeveniment, esdeveniment_usuari WHERE esdeveniment_usuari.id_usuari='".$id_usuari."' AND esdeveniment.id=esdeveniment_usuari.id_esdeveniment)
		   )
		)
		AS tabla_resultado
		WHERE tabla_resultado.data_esdeveniment='".$data_esdeveniments."'
		";
		
		//	obtenim els esdeveniments
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		
		//	preparem plantilla dels esdeveniments nous
		$plantilla="p_llista_esdeveniments_taula";
		$directori_plantilla="esdeveniment/p_llista_esdeveniments_taula.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_llista_esdeveniments_taula_fila', 'p_llista_esdeveniments_taula');
		
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el esdeveniment
				$esdeveniment=new I_esdeveniment();
				$esdeveniment->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_ESDEVENIMENT_DIA', $esdeveniment->nom); 
				$this->html->asignar('ID_ESDEVENIMENT_DIA', $esdeveniment->id);
				$this->html->asignar('DATA_CREACIO_ESDEVENIMENT_DIA', $esdeveniment->data_creacio);
				$this->html->asignar('DATA_ESDEVENIMENT_DIA', $esdeveniment->data_esdeveniment);
				$this->html->asignar('DESCRIPCIO_ESDEVENIMENT_DIA', $esdeveniment->descripcio);
				
				//		obtenim el destinataris de l'esdeveniment
				include('includes/php/destinataris_esdeveniment.php');
				
				//			asignem destinataris de lesdeveniment
				$this->html->asignar('DESTINATARIS_ESDEVENIMENT_DIA', $destinataris);

				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES_ESDEVENIMENTS_DIA', '+p_llista_esdeveniments_taula_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('TAULA', 'p_llista_esdeveniments_taula');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
		//CARREGUEM TASQUES QUE INICIEN EN AQUEST DIA
		
		//montem la query
		$query="(SELECT tasca.id FROM tasca, tasca_grup, usuari_grup, info_usuari_tasca WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=tasca_grup.id_grup AND tasca_grup.id_tasca=tasca.id AND tasca.data_inici='".$data_esdeveniments."' AND info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_estat!='1' GROUP BY tasca.id)
		UNION
		(SELECT tasca.id FROM tasca, tasca_usuari, info_usuari_tasca WHERE tasca_usuari.id_usuari='".$id_usuari."' AND tasca_usuari.id_tasca=tasca.id AND tasca.data_inici='".$data_esdeveniments."' AND info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_estat!='1' GROUP BY tasca.id)
		";
		
		//obtenim les tasques
		$connect->set_query($query);
		$llista=$connect->get_object_list();

		//insertem dades en el template
		//	preparem les plantilles interiors
		$plantilla="p_llista_esdeveniments_taula_inici_tasques";
		$directori_plantilla="esdeveniment/p_llista_esdeveniments_taula_inici_tasques.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_llista_esdeveniments_taula_inici_tasques_fila', 'p_llista_esdeveniments_taula_inici_tasques');
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim la tasca
				$tasca=new I_tasca();
				$tasca->carregar_dades_per_id($llista[$index]->id);
				
				//borrem variables pk no hi hagi duplicidad de variables
				$this->html->limpiar("MISSATGES_NOUS_TASQUES_LLISTA_INICI_TASQUES");
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_INICI_TASQUES', $tasca->nom); 
				$this->html->asignar('ID_TASCA_INICI_TASQUES', $tasca->id); 
				//		asignam el nombre de missatges no llegits de la fila actual
				$query="SELECT COUNT(DISTINCT llegit.id_missatge) AS nombre FROM llegit, missatge WHERE llegit.id_usuari='".$id_usuari."' AND llegit.id_missatge=missatge.id AND missatge.id_tasca='".$tasca->id."'";
				$connect->set_query($query);
				$llista_aux=$connect->get_object_list();
				if($llista_aux[0]->nombre!=0){
					$this->html->asignar("MISSATGES_NOUS_TASQUES_LLISTA_INICI_TASQUES","<span class='missatges_no_llegits'>".$llista_aux[0]->nombre."</span>");
				}
				
				// Asignem l'estat de la tasca
				$query="SELECT estat.nom FROM estat, info_usuari_tasca WHERE info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_tasca='".$tasca->id."' AND info_usuari_tasca.id_estat=estat.id";
				$connect->set_query($query);
				$llista_aux=$connect->get_object_list();
				$this->html->asignar('ESTAT_INICI_TASQUES', $llista_aux[0]->nom); 
				
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES_INICI_TASQUES', '+p_llista_esdeveniments_taula_inici_tasques_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('TAULA_INICI_TASQUES', 'p_llista_esdeveniments_taula_inici_tasques');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
		//CARREGUEM TASQUES QUE FINALITCEN EN AQUEST DIA
		
		//montem la query
		$query="(SELECT tasca.id FROM tasca, tasca_grup, usuari_grup, info_usuari_tasca WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=tasca_grup.id_grup AND tasca_grup.id_tasca=tasca.id AND tasca.data_fi='".$data_esdeveniments."' AND info_usuari_tasca.id_tasca=tasca.id AND info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_estat!='1' GROUP BY tasca.id)
		UNION
		(SELECT tasca.id FROM tasca, tasca_usuari, info_usuari_tasca WHERE tasca_usuari.id_usuari='".$id_usuari."' AND tasca_usuari.id_tasca=tasca.id AND tasca.data_fi='".$data_esdeveniments."' AND info_usuari_tasca.id_tasca=tasca.id AND info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_estat!='1' GROUP BY tasca.id)
		";
		
		//obtenim les tasques
		$connect->set_query($query);
		$llista=$connect->get_object_list();

		//insertem dades en el template
		//	preparem les plantilles interiors
		$plantilla="p_llista_esdeveniments_taula_fi_tasques";
		$directori_plantilla="esdeveniment/p_llista_esdeveniments_taula_fi_tasques.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_llista_esdeveniments_taula_fi_tasques_fila', 'p_llista_esdeveniments_taula_fi_tasques');
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim la tasca
				$tasca=new I_tasca();
				$tasca->carregar_dades_per_id($llista[$index]->id);
				
				//borrem variables pk no hi hagi duplicidad de variables
				$this->html->limpiar("MISSATGES_NOUS_TASQUES_LLISTA_FI_TASQUES");
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_FI_TASQUES', $tasca->nom); 
				$this->html->asignar('ID_TASCA_FI_TASQUES', $tasca->id); 
				//		asignam el nombre de missatges no llegits de la fila actual
				$query="SELECT COUNT(DISTINCT llegit.id_missatge) AS nombre FROM llegit, missatge WHERE llegit.id_usuari='".$id_usuari."' AND llegit.id_missatge=missatge.id AND missatge.id_tasca='".$tasca->id."'";
				$connect->set_query($query);
				$llista_aux=$connect->get_object_list();
				if($llista_aux[0]->nombre!=0){
					$this->html->asignar("MISSATGES_NOUS_TASQUES_LLISTA_FI_TASQUES","<span class='missatges_no_llegits'>".$llista_aux[0]->nombre."</span>");
				}
				
				// Asignem l'estat de la tasca
				$query="SELECT estat.nom FROM estat, info_usuari_tasca WHERE info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_tasca='".$tasca->id."' AND info_usuari_tasca.id_estat=estat.id";
				$connect->set_query($query);
				$llista_aux=$connect->get_object_list();
				$this->html->asignar('ESTAT_FI_TASQUES', $llista_aux[0]->nom); 
				
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES_FI_TASQUES', '+p_llista_esdeveniments_taula_fi_tasques_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('TAULA_FI_TASQUES', 'p_llista_esdeveniments_taula_fi_tasques');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
	}
	
	//funcionalitat per afegir contactes usuari
	function afegir_esdeveniment(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$nom=$_REQUEST["nom"];
		$descripcio=$_REQUEST["descripcio"];
		$data=$_REQUEST["data"];
		$llista_contactes_esdeveniment=$_REQUEST["selector_contactes"];
		$llista_grups_esdeveniment=$_REQUEST["selector_grups"];
		$llista_tasques_esdeveniment=$_REQUEST["selector_tasques"];
		
		//inserim nou esdeveniment
		$esdeveniment=new I_esdeveniment();
		$esdeveniment->nom=$nom;
		$esdeveniment->descripcio=$descripcio;
		$data_objecte = new DateTime($data);	
		$esdeveniment->data_esdeveniment=$data_objecte->format('Y-m-d');
		$data_objecte = new DateTime();	
		$esdeveniment->data_creacio=$data_objecte->format('Y-m-d');
		$esdeveniment->id_usuari=$id_usuari;	
		$id_esdeveniment=$esdeveniment->guardar_dades();
		
		//inserim contactes seleccionats en el esdeveniment
		$index=0;
		while($index < sizeof($llista_contactes_esdeveniment)){
			//	inserim relacio de contacte
			$esdeveniment_usuari=new I_esdeveniment_usuari();
			$esdeveniment_usuari->id_usuari=$llista_contactes_esdeveniment[$index];
			$esdeveniment_usuari->id_esdeveniment=$id_esdeveniment;
			$esdeveniment_usuari->guardar_dades();
			$index=$index+1;
		}
		//	inserim relacio desdeveniment amb usuari principal en cas necessari
		if($llista_contactes_esdeveniment!=""){
			//if($llista_grups_esdeveniment=="" and $llista_tasques_esdeveniment==""){
				//	inserim relacio de usuari principal
				$esdeveniment_usuari=new I_esdeveniment_usuari();
				$esdeveniment_usuari->id_usuari=$id_usuari;
				$esdeveniment_usuari->id_esdeveniment=$id_esdeveniment;
				$esdeveniment_usuari->guardar_dades();
			//}
		}
		
		//inserim grups seleccionats en esdeveniment
		$index=0;
		while($index < sizeof($llista_grups_esdeveniment)){
			$esdeveniment_grup=new I_esdeveniment_grup();
			$esdeveniment_grup->id_grup=$llista_grups_esdeveniment[$index];
			$esdeveniment_grup->id_esdeveniment=$id_esdeveniment;
			$esdeveniment_grup->guardar_dades();
			$index=$index+1;
		}
		
		//inserim contactes seleccionats en en esdeveniment
		$index=0;
		while($index < sizeof($llista_tasques_esdeveniment)){
			$esdeveniment_tasca=new I_esdeveniment_tasca();
			$esdeveniment_tasca->id_tasca=$llista_tasques_esdeveniment[$index];
			$esdeveniment_tasca->id_esdeveniment=$id_esdeveniment;
			$esdeveniment_tasca->guardar_dades();
			$index=$index+1;
		}
		
		//redireccionem
		header('Location: index.php?tasca=usuari.inici_usuari&plantilla=usuari.p_inici_usuari');
		
	}
	
	//funcionalitat per carregar les dades necessaries per afegir un grup
	function dades_afegir_esdeveniment(){
		
		//obtenim conexion a la base de dades
		$connect=new Db_connection();
		$connect->connect();

		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		
		//	carreguem els missatges nous
		include('includes/php/nombre_missatges_nous.php');
		
		//inserim dades en el selector de contactes
		//	montem query
		$query="SELECT usuari_usuari.id_usuari_contacte FROM usuari_usuari WHERE usuari_usuari.id_usuari_principal='".$id_usuari."'";
		//	obtenim els grups del lusuari actual
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		//	preparem les plantilles interiors
		$plantilla="p_afegir_esdeveniment_selector_contactes";
		$directori_plantilla="esdeveniment/p_afegir_esdeveniment_selector_contactes.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_afegir_esdeveniment_opcio_contacte', 'p_afegir_esdeveniment_selector_contactes');
		//	recorrem array de dades per inserirles
		$opcions="";
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$usuari=new I_usuari();
				$usuari->carregar_dades_per_id($llista[$index]->id_usuari_contacte);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_CONTACTE', $usuari->usuari); 
				$this->html->asignar('ID_CONTACTE', $usuari->id); 
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('OPCIONS_CONTACTES', '+p_afegir_esdeveniment_opcio_contacte');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('SELECTOR_CONTACTES', 'p_afegir_esdeveniment_selector_contactes');
			
		}
		
		//inserim dades en el selector de grups
		//	montem query
		$query="SELECT grup.id FROM usuari_grup, grup WHERE usuari_grup.id_usuari='".$id_usuari."' AND grup.id=usuari_grup.id_grup";
		//	obtenim els grups del lusuari actual
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		//	preparem les plantilles interiors
		$plantilla="p_afegir_esdeveniment_selector_grups";
		$directori_plantilla="esdeveniment/p_afegir_esdeveniment_selector_grups.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_afegir_esdeveniment_opcio_grup', 'p_afegir_esdeveniment_selector_grups');
		//	recorrem array de dades per inserirles
		$opcions="";
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$grup=new I_grup();
				$grup->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_GRUP', $grup->nom); 
				$this->html->asignar('ID_GRUP', $grup->id); 
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('OPCIONS_GRUPS', '+p_afegir_esdeveniment_opcio_grup');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('SELECTOR_GRUPS', 'p_afegir_esdeveniment_selector_grups');
			
		}
		
		//inserim dades en el selector de tasques
		//	montem query
		$query="(SELECT tasca.id FROM tasca, tasca_grup, usuari_grup, info_usuari_tasca WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=tasca_grup.id_grup AND tasca_grup.id_tasca=tasca.id AND info_usuari_tasca.id_tasca=tasca.id AND info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_estat!='1' GROUP BY tasca.id)
		UNION
		(SELECT tasca.id FROM tasca, tasca_usuari, info_usuari_tasca WHERE tasca_usuari.id_usuari='".$id_usuari."' AND tasca_usuari.id_tasca=tasca.id AND info_usuari_tasca.id_tasca=tasca.id AND info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_estat!='1' GROUP BY tasca.id)";

		//	obtenim els grups del lusuari actual
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		//	preparem les plantilles interiors
		$plantilla="p_afegir_esdeveniment_selector_tasques";
		$directori_plantilla="esdeveniment/p_afegir_esdeveniment_selector_tasques.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_afegir_esdeveniment_opcio_tasca', 'p_afegir_esdeveniment_selector_tasques');
		//	recorrem array de dades per inserirles
		$opcions="";
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$tasca=new I_tasca();
				$tasca->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_TASCA', $tasca->nom); 
				$this->html->asignar('ID_TASCA', $tasca->id); 
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('OPCIONS_TASQUES', '+p_afegir_esdeveniment_opcio_tasca');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('SELECTOR_TASQUES', 'p_afegir_esdeveniment_selector_tasques');
			
		}
		
	}
	
}
?>
