<?
/**
*    Codi clase B_grup.php
*
*    @autor Jose Roig Torres
*
*    @tasca projecte de fi de carrera
*
*    @universitat Universitat Oberta de Catalunya
*
*    @area aplicacions web per treball col·laboratiu
*
*    @tema disseny i prototipatge d'un sistema d'esdeveniments per a dispositius mòbils de treball en grup
*/

include_once('libraries/php/db_connection.php');
include_once('src/integration/i_grup.php');
include_once('src/integration/i_usuari.php');
include_once('src/integration/i_missatge.php');
include_once('src/integration/i_esdeveniment.php');
include_once('src/integration/i_esdeveniment_grup.php');
include_once('src/integration/i_usuari_grup.php');
include_once('src/integration/i_llegit.php');
include_once('libraries/php/delete_helper.php');

class B_grup {
	
	//variable de nok template
	var $html;
	
	//constructor
	function B_grup($html){
		$this->html=$html;
	}
	
	//funcionalitat per vorer els contactes de lusuari actual
	function llista_grups(){
		
		//obtenim els parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		
		//creem la conexio
		$connect=new Db_connection();
		$connect->connect();
		
		//	carreguem els missatges nous
		include('includes/php/nombre_missatges_nous.php');
		
		//monetem la query
		$query="SELECT grup.nom, grup.id, grup.eliminat FROM usuari_grup, grup WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=grup.id";
		
		//obtenim els contactes
		$connect->set_query($query);
		$llista=$connect->get_object_list();

		//insertem dades en el template
		//	preparem les plantilles interiors
		$plantilla="p_llista_grups_taula";
		$directori_plantilla="grup/p_llista_grups_taula.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_llista_grups_fila', 'p_llista_grups_taula');
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$grup=new I_grup();
				$grup->carregar_dades_per_id($llista[$index]->id);
				
				//borrem variables pk no hi hagi duplicidad de variables
				$this->html->limpiar("MISSATGES_NOUS_GRUPS_LLISTA");
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM', $grup->nom); 
				$this->html->asignar('ID_GRUP', $grup->id);
				//		asignam el nombre de missatges no llegits de la fila actual
				$query="SELECT COUNT(DISTINCT llegit.id_missatge) AS nombre FROM llegit, missatge WHERE llegit.id_usuari='".$id_usuari."' AND llegit.id_missatge=missatge.id AND missatge.id_grup='".$grup->id."'";
				$connect->set_query($query);
				$llista_aux=$connect->get_object_list();
				if($llista_aux[0]->nombre!=0){
					$this->html->asignar("MISSATGES_NOUS_GRUPS_LLISTA","<span class='missatges_no_llegits'>".$llista_aux[0]->nombre."</span>");
				}
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES', '+p_llista_grups_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('TAULA', 'p_llista_grups_taula');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
	}
	
	//funcionalitat per vorer els contactes de lusuari actual
	function detall_grup(){
		
		//obtenim els parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_grup=$_REQUEST['id_grup'];
		$grup=new I_grup();
		$grup->carregar_dades_per_id($id_grup);
		$nom_grup=$grup->nom;
		
		//obtenim conexio
		$connect=new Db_connection();
		$connect->connect();

		//	preparem les plantilles interiors
		$plantilla="p_detall_grup_missatges";
		$directori_plantilla="grup/p_detall_grup_missatges.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_detall_grup_fila', 'p_detall_grup_missatges');
		
		//  INSERIM DADES EN PLANTILLA PRINCIPAL
		$this->html->asignar('ID_GRUP', $id_grup);
		$this->html->asignar('NOM_GRUP', $nom_grup);
		
		//		INSERIM DADES DELS USUARIS DEL GRUP
		$query="SELECT id_usuari FROM usuari_grup WHERE id_grup='".$id_grup."'";
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		$camp_membres="";
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$us=new I_usuari();
				$us->carregar_dades_per_id($llista[$index]->id_usuari);
				
				// Asignam valors a la fila actual 
				if($index != sizeof($llista)-1){
					$camp_membres=$camp_membres.$us->usuari.", ";
				}else{
					$camp_membres=$camp_membres.$us->usuari;	
				}
				$index=$index+1;
				
			}
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		$this->html->asignar('MEMBRES', $camp_membres);
		
		//		INSERIM ELS MISSATGES
		$query="SELECT id FROM missatge WHERE id_grup='".$id_grup."' ORDER BY missatge.data_hora";
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$missatge=new I_missatge();
				$missatge->carregar_dades_per_id($llista[$index]->id);
				
				// obtenim l'emisor del missatge
				$usuari=new I_usuari();
				$usuari->carregar_dades_per_id($missatge->id_usuari_emisor);
				
				// Asignam valors a la fila actual
				if($usuari->id==$id_usuari){
					$this->html->asignar('ROL_EMISOR', "usuari_lector"); 
				}else{
					$this->html->asignar('ROL_EMISOR', "usuari_no_lector");
				}
				$this->html->asignar('USUARI', $usuari->usuari); 
				$this->html->asignar('TEXT', $missatge->missatge);
				$data = new DateTime($missatge->data_hora);
				$data->format('Y-m-d H:i:s');
				$this->html->asignar('DATA', $data->format('Y-m-d')); 
				$this->html->asignar('HORA', $data->format('H:i:s'));  
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES', '+p_detall_grup_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('MISSATGES', 'p_detall_grup_missatges');
			
			//borram els apuntadors a missatges no llegits
			$query="DELETE llegit FROM llegit, missatge WHERE llegit.id_usuari='".$id_usuari."' AND llegit.id_missatge=missatge.id AND missatge.id_grup='".$id_grup."'";
			$connect->set_query($query);
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
		//	CARREGUEM MISSATGES NOUS
		include('includes/php/nombre_missatges_nous.php');
		
		//	CARREGUEM ESDEVENIMENTS DEL GRUP 
		
		//	montem la query
		$query="
		SELECT esdeveniment.* FROM esdeveniment, esdeveniment_grup WHERE
		esdeveniment_grup.id_grup='".$id_grup."' AND esdeveniment_grup.id_esdeveniment=esdeveniment.id
		";
		
		//	obtenim els esdeveniments
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		
		//	preparem plantilla dels esdeveniments nous
		$plantilla="p_detall_grup_esdeveniments";
		$directori_plantilla="grup/p_detall_grup_esdeveniments.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_detall_grup_esdeveniments_fila', 'p_detall_grup_esdeveniments');
		
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el esdeveniment
				$esdeveniment=new I_esdeveniment();
				$esdeveniment->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_ESDEVENIMENT', $esdeveniment->nom); 
				$this->html->asignar('ID_ESDEVENIMENT', $esdeveniment->id);
				$this->html->asignar('DATA_CREACIO_ESDEVENIMENT', $esdeveniment->data_creacio);
				$this->html->asignar('DATA_ESDEVENIMENT', $esdeveniment->data_esdeveniment);
				$this->html->asignar('DESCRIPCIO_ESDEVENIMENT', $esdeveniment->descripcio);
				
				//		obtenim el destinataris de l'esdeveniment
				include('includes/php/destinataris_esdeveniment.php');
				
				//			asignem destinataris de lesdeveniment
				$this->html->asignar('DESTINATARIS_ESDEVENIMENT', $destinataris);

				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES_ESDEVENIMENTS', '+p_detall_grup_esdeveniments_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('ESDEVENIMENTS', 'p_detall_grup_esdeveniments');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
	}
	
	//funcionalitat per afegir contactes usuari
	function afegir_grup(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$nom=$_REQUEST["nom"];
		$llista_usuaris_grup=$_REQUEST["selector"];
		
		//inserim nou grup
		$grup=new I_grup();
		$grup->nom=$nom;
		$id_grup=$grup->guardar_dades();
		
		//inserim nova fila usuari_grup per a l'usuari actual
		$usuari_grup=new I_usuari_grup();
		$usuari_grup->id_usuari=$id_usuari;
		$usuari_grup->id_grup=$id_grup;
		$usuari_grup->guardar_dades();
		
		//inserim usuaris seleccionats en el grup
		$index=0;
		while($index < sizeof($llista_usuaris_grup)){
			$usuari_grup=new I_usuari_grup();
			$usuari_grup->id_usuari=$llista_usuaris_grup[$index];
			$usuari_grup->id_grup=$id_grup;
			$usuari_grup->guardar_dades();
			$index=$index+1;
		}
		
		//redireccionem
		header('Location: index.php?tasca=grup.llista_grups&plantilla=grup.p_llista_grups');
		
	}
	
	//funcionalitat per afegir missatges el foro del grup
	function afegir_missatge_grup(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$mis=$_REQUEST["missatge"];
		$id_grup=$_REQUEST['id_grup'];
		
		//inserim nou missatge
		$missatge=new I_missatge();
		$missatge->missatge=$mis;
		$missatge->id_usuari_emisor=$id_usuari;
		$missatge->id_grup=$id_grup;
		$data = new DateTime();
		$missatge->data_hora=$data->format('Y-m-d H:i:s');
		$id_missatge=$missatge->guardar_dades();
		
		//inserim files per marcar el missatge com a no llegit
		//	obtenim les persones a les que va dirigit el missatge
		$connect=new Db_connection();
		$connect->connect();
		$query="SELECT usuari_grup.id_usuari FROM missatge, usuari_grup WHERE missatge.id='".$id_missatge."' AND missatge.id_grup=usuari_grup.id_grup AND usuari_grup.id_usuari!='".$id_usuari."' GROUP BY usuari_grup.id_usuari";
		
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$us=new I_usuari();
				$us->carregar_dades_per_id($llista[$index]->id_usuari);
				
				//inserim files per marcar el missatge com a no llegit
				$llegit=new I_llegit();
				$llegit->id_usuari=$llista[$index]->id_usuari;
				$llegit->id_missatge=$id_missatge;
				$llegit->llegit=0;
				$llegit->guardar_dades();
				
				$index=$index+1;
				
			}
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
		//redireccionem
		header('Location: index.php?tasca=grup.detall_grup&plantilla=grup.p_detall_grup&id_grup='.$id_grup);
		
	}
	
	//funcionalitat per afegir esdeveniments per el contacte
	function afegir_esdeveniment_grup(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_grup=$_REQUEST['id_grup'];
		$nom=$_REQUEST["nom"];
		$descripcio=$_REQUEST["descripcio"];
		$data=$_REQUEST["data"];
		
		//inserim nou esdeveniment
		$esdeveniment=new I_esdeveniment();
		$esdeveniment->nom=$nom;
		$esdeveniment->descripcio=$descripcio;
		$data_objecte = new DateTime($data);	
		$esdeveniment->data_esdeveniment=$data_objecte->format('Y-m-d');
		$data_objecte = new DateTime();	
		$esdeveniment->data_creacio=$data_objecte->format('Y-m-d');
		$esdeveniment->id_usuari=$id_usuari;	
		$id_esdeveniment=$esdeveniment->guardar_dades();
		
		//	inserim relacio amb el grup
		$esdeveniment_grup=new I_esdeveniment_grup();
		$esdeveniment_grup->id_grup=$id_grup;
		$esdeveniment_grup->id_esdeveniment=$id_esdeveniment;
		$esdeveniment_grup->guardar_dades();
		
		//redireccionem
		header('Location: index.php?tasca=grup.detall_grup&plantilla=grup.p_detall_grup&id_grup='.$id_grup);
		
	}
	
	//funcionalitat per carregar les dades necessaries per afegir un esdeveniment de grup
	function dades_afegir_esdeveniment_grup(){
		
		//obtenim conexion a la base de dades
		$connect=new Db_connection();
		$connect->connect();
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_grup=$_REQUEST["id_grup"];
		
		//carreguem dades de la plantilla
		$this->html->asignar('ID_GRUP', $id_grup);
		
		//	carreguem els missatges nous
		include('includes/php/nombre_missatges_nous.php');
		
	}
	
	//funcionalitat per carregar les dades necessaries per afegir un grup
	function dades_afegir_grup(){
		
		//obtenim conexion a la base de dades
		$connect=new Db_connection();
		$connect->connect();
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		
		//	carreguem els missatges nous
		include('includes/php/nombre_missatges_nous.php');
		
		//montem query
		$query="SELECT usuari.id FROM usuari_usuari, usuari WHERE usuari_usuari.id_usuari_principal=".$id_usuari." AND usuari.id=usuari_usuari.id_usuari_contacte";
		
		//obtenim els contactes del lusuari actual
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		
		//	preparem les plantilles interiors
		$plantilla="p_afegir_grup_selector";
		$directori_plantilla="grup/p_afegir_grup_selector.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_afegir_grup_opcio', 'p_afegir_grup_selector');
		
		//	recorrem array de dades per inserirles
		$opcions="";
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$usuari=new I_usuari();
				$usuari->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOMCONTACTE', $usuari->nom); 
				$this->html->asignar('IDCONTACTE', $usuari->id); 
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('OPCIONS', '+p_afegir_grup_opcio');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('SELECTOR', 'p_afegir_grup_selector');
			
		}
		
	}
	
	//funcionalitat esborrar un grup
	function borrar_grup(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_grup=$_REQUEST["id_grup"];
		
		//borrem la tasca
		$delete_helper=new Delete_helper();
		$delete_helper->esborrar_grup($id_usuari, $id_grup);
		
		//redireccionem
		header('Location: index.php?tasca=grup.llista_grups&plantilla=grup.p_llista_grups');
		
	}
	
}
?>
