<?
/**
*    Codi clase B_tasca.php
*
*    @autor Jose Roig Torres
*
*    @tasca projecte de fi de carrera
*
*    @universitat Universitat Oberta de Catalunya
*
*    @area aplicacions web per treball col·laboratiu
*
*    @tema disseny i prototipatge d'un sistema d'esdeveniments per a dispositius mòbils de treball en grup
*/

include_once('libraries/php/db_connection.php');
include_once('src/integration/i_grup.php');
include_once('src/integration/i_usuari.php');
include_once('src/integration/i_missatge.php');
include_once('src/integration/i_tasca.php');
include_once('src/integration/i_estat.php');
include_once('src/integration/i_tasca_grup.php');
include_once('src/integration/i_tasca_usuari.php');
include_once('src/integration/i_llegit.php');
include_once('src/integration/i_info_usuari_tasca.php');
include_once('src/integration/i_esdeveniment.php');
include_once('src/integration/i_esdeveniment_tasca.php');
include_once('src/integration/i_prioritat.php');
include_once('src/integration/i_usuari_grup.php');
include_once('libraries/php/delete_helper.php');

class B_tasca {
	
	//variable de nok template
	var $html;
	
	//constructor
	function B_tasca($html){
		$this->html=$html;
	}
	
	//funcionalitat per vorer els contactes de lusuari actual
	function llista_tasques(){
		
		//obtenim els parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		
		//generem la conexio
		$connect=new Db_connection();
		$connect->connect();
		
		//	carreguem els missatges nous
		include('includes/php/nombre_missatges_nous.php');
		
		//montem la query
		$query="(SELECT tasca.id FROM tasca, tasca_grup, usuari_grup, info_usuari_tasca WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=tasca_grup.id_grup AND tasca_grup.id_tasca=tasca.id AND info_usuari_tasca.id_tasca=tasca.id AND info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_estat!='1' GROUP BY tasca.id)
		UNION
		(SELECT tasca.id FROM tasca, tasca_usuari, info_usuari_tasca WHERE tasca_usuari.id_usuari='".$id_usuari."' AND tasca_usuari.id_tasca=tasca.id AND info_usuari_tasca.id_tasca=tasca.id AND info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_estat!='1' GROUP BY tasca.id)";
		
		//obtenim les tasques
		$connect->set_query($query);
		$llista=$connect->get_object_list();

		//insertem dades en el template
		//	preparem les plantilles interiors
		$plantilla="p_llista_tasques_taula";
		$directori_plantilla="tasca/p_llista_tasques_taula.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_llista_tasques_fila', 'p_llista_tasques_taula');
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim la tasca
				$tasca=new I_tasca();
				$tasca->carregar_dades_per_id($llista[$index]->id);
				
				//borrem variables pk no hi hagi duplicidad de variables
				$this->html->limpiar("MISSATGES_NOUS_TASQUES_LLISTA");
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM', $tasca->nom); 
				$this->html->asignar('ID_TASCA', $tasca->id); 
				//		asignam el nombre de missatges no llegits de la fila actual
				$query="SELECT COUNT(DISTINCT llegit.id_missatge) AS nombre FROM llegit, missatge WHERE llegit.id_usuari='".$id_usuari."' AND llegit.id_missatge=missatge.id AND missatge.id_tasca='".$tasca->id."'";
				$connect->set_query($query);
				$llista_aux=$connect->get_object_list();
				if($llista_aux[0]->nombre!=0){
					$this->html->asignar("MISSATGES_NOUS_TASQUES_LLISTA","<span class='missatges_no_llegits'>".$llista_aux[0]->nombre."</span>");
				}
				
				// Asignem l'estat de la tasca
				$query="SELECT estat.nom FROM estat, info_usuari_tasca WHERE info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_tasca='".$tasca->id."' AND info_usuari_tasca.id_estat=estat.id";
				$connect->set_query($query);
				$llista_aux=$connect->get_object_list();
				$this->html->asignar('ESTAT', $llista_aux[0]->nom); 
				
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES', '+p_llista_tasques_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('TAULA', 'p_llista_tasques_taula');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
	}
	
	//funcionalitat per vorer els contactes de lusuari actual
	function detall_tasca(){
		
		//obtenim els parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_tasca=$_REQUEST['id_tasca'];
		$tasca=new I_tasca();
		$tasca->carregar_dades_per_id($id_tasca);
		$nom_tasca=$tasca->nom;
		
		//obtenim conexio
		$connect=new Db_connection();
		$connect->connect();
		
		//	preparem les plantilles interiors
		$plantilla="p_detall_tasca_missatges";
		$directori_plantilla="tasca/p_detall_tasca_missatges.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_detall_tasca_fila', 'p_detall_tasca_missatges');
		
		//  inserim dades en platilla principal
		$this->html->asignar('ID_TASCA', $id_tasca);
		$this->html->asignar('NOM_TASCA', $nom_tasca);
		
		//		inserim dades dels grups de la tasca
		$query="SELECT id_grup FROM tasca_grup WHERE id_tasca='".$id_tasca."'";
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		$camp_grups="";
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$gr=new I_grup();
				$gr->carregar_dades_per_id($llista[$index]->id_grup);
				
				// Asignam valors a la fila actual 
				if($index != sizeof($llista)-1){
					$camp_grups=$camp_grups.$gr->nom.", ";
				}else{
					$camp_grups=$camp_grups.$gr->nom;	
				}
				$index=$index+1;
				
			}
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		$this->html->asignar('GRUPS', $camp_grups);
		
		//		inserim dades dels contactes de la tasca
		$query="SELECT id_usuari FROM tasca_usuari WHERE id_tasca='".$id_tasca."'";
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		$camp_contactes="";
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$us=new I_usuari();
				$us->carregar_dades_per_id($llista[$index]->id_usuari);
				
				// Asignam valors a la fila actual 
				if($index != sizeof($llista)-1){
					$camp_contactes=$camp_contactes.$us->usuari.", ";
				}else{
					$camp_contactes=$camp_contactes.$us->usuari;	
				}
				$index=$index+1;
				
			}
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		$this->html->asignar('CONTACTES', $camp_contactes);
		
		//		inserim dades del missatges
		$query="SELECT id FROM missatge WHERE id_tasca='".$id_tasca."' ORDER BY missatge.data_hora";
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$missatge=new I_missatge();
				$missatge->carregar_dades_per_id($llista[$index]->id);
				
				// obtenim l'emisor del missatge
				$usuari=new I_usuari();
				$usuari->carregar_dades_per_id($missatge->id_usuari_emisor);
				
				// Asignam valors a la fila actual
				if($usuari->id==$id_usuari){
					$this->html->asignar('ROL_EMISOR', "usuari_lector"); 
				}else{
					$this->html->asignar('ROL_EMISOR', "usuari_no_lector");
				}
				$this->html->asignar('USUARI', $usuari->usuari); 
				$this->html->asignar('TEXT', $missatge->missatge);
				$data = new DateTime($missatge->data_hora);
				$data->format('Y-m-d H:i:s');
				$this->html->asignar('DATA', $data->format('Y-m-d')); 
				$this->html->asignar('HORA', $data->format('H:i:s'));  
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES', '+p_detall_tasca_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('MISSATGES', 'p_detall_tasca_missatges');
			
			//borram els apuntadors a missatges no llegits
			$query="DELETE llegit FROM llegit, missatge WHERE llegit.id_usuari='".$id_usuari."' AND llegit.id_missatge=missatge.id AND missatge.id_tasca='".$id_tasca."'";
			$connect->set_query($query);
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
		//	carreguem els missatges nous
		include('includes/php/nombre_missatges_nous.php');
		
		//	CARREGUEM ESDEVENIMENTS DEL GRUP 
		
		//	montem la query
		$query="
		SELECT esdeveniment.* FROM esdeveniment, esdeveniment_tasca WHERE
		esdeveniment_tasca.id_tasca='".$id_tasca."' AND esdeveniment_tasca.id_esdeveniment=esdeveniment.id
		";
		
		//	obtenim els esdeveniments
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		
		//	preparem plantilla dels esdeveniments nous
		$plantilla="p_detall_tasca_esdeveniments";
		$directori_plantilla="tasca/p_detall_tasca_esdeveniments.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_detall_tasca_esdeveniments_fila', 'p_detall_tasca_esdeveniments');
		
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el esdeveniment
				$esdeveniment=new I_esdeveniment();
				$esdeveniment->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_ESDEVENIMENT', $esdeveniment->nom); 
				$this->html->asignar('ID_ESDEVENIMENT', $esdeveniment->id);
				$this->html->asignar('DATA_CREACIO_ESDEVENIMENT', $esdeveniment->data_creacio);
				$this->html->asignar('DATA_ESDEVENIMENT', $esdeveniment->data_esdeveniment);
				$this->html->asignar('DESCRIPCIO_ESDEVENIMENT', $esdeveniment->descripcio);
				
				//		obtenim el destinataris de l'esdeveniment
				include('includes/php/destinataris_esdeveniment.php');
				
				//			asignem destinataris de lesdeveniment
				$this->html->asignar('DESTINATARIS_ESDEVENIMENT', $destinataris);

				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES_ESDEVENIMENTS', '+p_detall_tasca_esdeveniments_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('ESDEVENIMENTS', 'p_detall_tasca_esdeveniments');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
		//CARREGUEM DADES DEL APARTAT DEDICIO DE LA TASCA
		
		//inserim dades en el selector destats
		
		//	montem query
		$query="SELECT info_usuari_tasca.* FROM info_usuari_tasca WHERE info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_tasca='".$id_tasca."'";
		//	obtenim el estat de una tasca
		$connect->set_query($query);
		$llista_aux=$connect->get_object_list();
		//	inserim comentaris en el seu lloc respectiu
		$this->html->asignar('COMENTARIS_TASCA', $llista_aux[0]->comentaris); 
		
		
		//	montem query
		$query="SELECT estat.* FROM estat WHERE estat.id!='1'";
		//	obtenim els estat de una tasca
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		
		//	preparem les plantilles interiors
		$plantilla="p_detall_tasca_selector_estat";
		$directori_plantilla="tasca/p_detall_tasca_selector_estat.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_detall_tasca_selector_estat_opcio', 'p_detall_tasca_selector_estat');
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$estat=new I_estat();
				$estat->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOMESTAT', $estat->nom);
				if($llista_aux[0]->id_estat!=$estat->id){
					$this->html->asignar('PARAMETRESESTAT', 'value="'.$estat->id.'"');
				}else{
					$this->html->asignar('PARAMETRESESTAT', 'value="'.$estat->id.'" selected');
				}
				
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('OPCIONSESTAT', '+p_detall_tasca_selector_estat_opcio');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('SELECTOR_ESTAT', 'p_detall_tasca_selector_estat');
			
		}
		
	}
	
	//funcionalitat per afegir contactes usuari
	function afegir_tasca(){
		
		$grup_inserit=false;
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$nom=$_REQUEST["nom"];
		$id_prioritat=$_REQUEST["selector_prioritat"];
		$data_inici=$_REQUEST["data_inici"];
		$data_fi=$_REQUEST["data_fi"];
		$llista_grups_tasca=$_REQUEST["selector"];
		$llista_contactes_tasca=$_REQUEST["selector_contactes"];
		
		//inserim nova tasca
		$tasca=new I_tasca();
		$tasca->nom=$nom;
		$tasca->id_prioritat=$id_prioritat;
		if($data_inici!=""){
			$data = new DateTime($data_inici);		
			$tasca->data_inici=$data->format('Y-m-d');		
		}
		if($data_fi!=""){
			$data = new DateTime($data_fi);
			$tasca->data_fi=$data->format('Y-m-d');
		}
		$id_tasca=$tasca->guardar_dades();
		
		//inserim grups seleccionats en la tasca
		$index=0;
		while($index < sizeof($llista_grups_tasca)){
			$tasca_grup=new I_tasca_grup();
			$tasca_grup->id_grup=$llista_grups_tasca[$index];
			$tasca_grup->id_tasca=$id_tasca;
			$tasca_grup->guardar_dades();
			$grup_inserit=true;
			$index=$index+1;
		}
		
		//en cas de que no hagi cap grup inserit, s'ha dinserir lusuari a dins la tasca
		if($grup_inserit==false){
			$llista_contactes_tasca[]=$id_usuari;
		}
		
		//inserim contactes seleccionats en la tasca
		$index=0;
		while($index < sizeof($llista_contactes_tasca)){
			$tasca_usuari=new I_tasca_usuari();
			$tasca_usuari->id_usuari=$llista_contactes_tasca[$index];
			$tasca_usuari->id_tasca=$id_tasca;
			$tasca_usuari->guardar_dades();
			$index=$index+1;
		}
		
		//inserim les files de la info de la tasca per cadascun dels usuaris de la tasca
		$connect=new Db_connection();
		$connect->connect();
		$query="
		SELECT usuari_grup.id_usuari FROM usuari_grup, tasca_grup WHERE tasca_grup.id_tasca='".$id_tasca."' AND  tasca_grup.id_grup=usuari_grup.id_grup GROUP BY usuari_grup.id_usuari 
		UNION
		SELECT tasca_usuari.id_usuari FROM tasca_usuari WHERE tasca_usuari.id_tasca='".$id_tasca."' GROUP BY tasca_usuari.id_usuari 
		";
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				//inserim files amb la informacio inicial de la tasca per lusuari
				$info_usuari_tasca=new I_info_usuari_tasca();
				//	marquem tasca com no inicidada
				$info_usuari_tasca->id_estat=2;
				//	inserim altres dades
				$info_usuari_tasca->id_usuari=$llista[$index]->id_usuari;
				$info_usuari_tasca->id_tasca=$id_tasca;
				$info_usuari_tasca->guardar_dades();
				
				$index=$index+1;
				
			}
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
		//redireccionem
		header('Location: index.php?tasca=tasca.llista_tasques&plantilla=tasca.p_llista_tasques');
		
	}
	
	//funcionalitat per editar les dades d'una tasca
	function editar_tasca(){
	
		//obtenim els parametres incials
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_tasca=$_REQUEST["id_tasca"];
		$comentaris=$_REQUEST["comentaris"];
		$id_estat=$_REQUEST["selector_estat"];
		
		//obtenim lidentificador de info_usuari_tasca
		$connect=new Db_connection();
		$connect->connect();
		$query="SELECT info_usuari_tasca.* FROM info_usuari_tasca WHERE info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_tasca='".$id_tasca."'";
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		
		//guardem dades dedicio de la tasca
		$info_usuari_tasca=new I_info_usuari_tasca();
		$info_usuari_tasca->carregar_dades_per_id($llista[0]->id);
		$info_usuari_tasca->id_estat=$id_estat;
		$info_usuari_tasca->comentaris=$comentaris;
		$info_usuari_tasca->guardar_dades();
	
		//redireccionem
		header('Location: index.php?tasca=tasca.detall_tasca&plantilla=tasca.p_detall_tasca&id_tasca='.$id_tasca.'');
		
	}
	
	//funcionalitat per afegir missatges el foro del grup
	function afegir_missatge_tasca(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$mis=$_REQUEST["missatge"];
		$id_tasca=$_REQUEST['id_tasca'];
		
		//inserim nou missatge
		$missatge=new I_missatge();
		$missatge->missatge=$mis;
		$missatge->id_usuari_emisor=$id_usuari;
		$missatge->id_tasca=$id_tasca;
		$data = new DateTime();
		$missatge->data_hora=$data->format('Y-m-d H:i:s');
		$id_missatge=$missatge->guardar_dades();
		
		//inserim files per marcar el missatge com a no llegit
		//	obtenim les persones a les que va dirigit el missatge
		$connect=new Db_connection();
		$connect->connect();
		$query="
		SELECT usuari_grup.id_usuari FROM missatge, usuari_grup, tasca_grup WHERE missatge.id='".$id_missatge."' AND missatge.id_tasca=tasca_grup.id_tasca AND tasca_grup.id_grup=usuari_grup.id_grup AND usuari_grup.id_usuari!='".$id_usuari."' GROUP BY usuari_grup.id_usuari 
		UNION
		SELECT tasca_usuari.id_usuari FROM tasca_usuari WHERE tasca_usuari.id_tasca='".$id_tasca."' AND tasca_usuari.id_usuari!='".$id_usuari."' GROUP BY tasca_usuari.id_usuari 
		";
		
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$us=new I_usuari();
				$us->carregar_dades_per_id($llista[$index]->id_usuari);
				
				//inserim files per marcar el missatge com a no llegit
				$llegit=new I_llegit();
				$llegit->id_usuari=$llista[$index]->id_usuari;
				$llegit->id_missatge=$id_missatge;
				$llegit->llegit=0;
				$llegit->guardar_dades();
				
				$index=$index+1;
				
			}
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
		//redireccionem
		header('Location: index.php?tasca=tasca.detall_tasca&plantilla=tasca.p_detall_tasca&id_tasca='.$id_tasca);
		
	}
	
	//funcionalitat per afegir esdeveniments per la tasca
	function afegir_esdeveniment_tasca(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_tasca=$_REQUEST['id_tasca'];
		$nom=$_REQUEST["nom"];
		$descripcio=$_REQUEST["descripcio"];
		$data=$_REQUEST["data"];
		
		//inserim nou esdeveniment
		$esdeveniment=new I_esdeveniment();
		$esdeveniment->nom=$nom;
		$esdeveniment->descripcio=$descripcio;
		$data_objecte = new DateTime($data);	
		$esdeveniment->data_esdeveniment=$data_objecte->format('Y-m-d');
		$data_objecte = new DateTime();	
		$esdeveniment->data_creacio=$data_objecte->format('Y-m-d');
		$esdeveniment->id_usuari=$id_usuari;	
		$id_esdeveniment=$esdeveniment->guardar_dades();
		
		//	inserim relacio amb la tasca
		$esdeveniment_tasca=new I_esdeveniment_tasca();
		$esdeveniment_tasca->id_tasca=$id_tasca;
		$esdeveniment_tasca->id_esdeveniment=$id_esdeveniment;
		$esdeveniment_tasca->guardar_dades();
		
		//redireccionem
		header('Location: index.php?tasca=tasca.detall_tasca&plantilla=tasca.p_detall_tasca&id_tasca='.$id_tasca);
		
	}
	
	//funcionalitat per carregar les dades necessaries per afegir un esdeveniment de tasca
	function dades_afegir_esdeveniment_tasca(){
		
		//obtenim conexion a la base de dades
		$connect=new Db_connection();
		$connect->connect();
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_tasca=$_REQUEST["id_tasca"];
		
		//carreguem dades de la plantilla
		$this->html->asignar('ID_TASCA', $id_tasca);
		
		//	carreguem els missatges nous
		include('includes/php/nombre_missatges_nous.php');
		
	}
	
	//funcionalitat per carregar les dades necessaries per afegir un grup
	function dades_afegir_tasca(){
		
		//obtenim conexion a la base de dades
		$connect=new Db_connection();
		$connect->connect();

		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		
		//	carreguem els missatges nous
		include('includes/php/nombre_missatges_nous.php');
		
		//inserim dades en el selector de prioritats
		//	montem query
		$query="SELECT prioritat.id FROM prioritat";
		//	obtenim els grups del lusuari actual
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		
		//	preparem les plantilles interiors
		$plantilla="p_afegir_tasca_selector_prioritat";
		$directori_plantilla="tasca/p_afegir_tasca_selector_prioritat.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_afegir_tasca_opcio_prioritat', 'p_afegir_tasca_selector_prioritat');
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$prioritat=new I_prioritat();
				$prioritat->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOMPRIORITAT', $prioritat->nom); 
				$this->html->asignar('IDPRIORITAT', $prioritat->id); 
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('OPCIONSPRIORITAT', '+p_afegir_tasca_opcio_prioritat');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('SELECTORPRIORITAT', 'p_afegir_tasca_selector_prioritat');
			
		}
		
		//inserim dades en el selector de grups
		//	montem query
		$query="SELECT grup.id FROM usuari_grup, grup WHERE usuari_grup.id_usuari='".$id_usuari."' AND grup.id=usuari_grup.id_grup";
		//	obtenim els grups del lusuari actual
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		//	preparem les plantilles interiors
		$plantilla="p_afegir_tasca_selector";
		$directori_plantilla="tasca/p_afegir_tasca_selector.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_afegir_tasca_opcio', 'p_afegir_tasca_selector');
		//	recorrem array de dades per inserirles
		$opcions="";
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$grup=new I_grup();
				$grup->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOMGRUP', $grup->nom); 
				$this->html->asignar('IDGRUP', $grup->id); 
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('OPCIONS', '+p_afegir_tasca_opcio');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('SELECTOR', 'p_afegir_tasca_selector');
			
		}
		
		//inserim dades en el selector de contactes
		//	montem query
		$query="SELECT usuari.id FROM usuari_usuari, usuari WHERE usuari_usuari.id_usuari_principal='".$id_usuari."' AND usuari.id=usuari_usuari.id_usuari_contacte";
		//	obtenim els contactes del lusuari actual
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		//	preparem les plantilles interiors
		$plantilla="p_afegir_tasca_selector_contactes";
		$directori_plantilla="tasca/p_afegir_tasca_selector_contactes.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_afegir_tasca_opcio_contacte', 'p_afegir_tasca_selector_contactes');
		//	recorrem array de dades per inserirles
		$opcions="";
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$usuari=new I_usuari();
				$usuari->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOMCONTACTE', $usuari->nom); 
				$this->html->asignar('IDCONTACTE', $usuari->id); 
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('OPCIONSCONTACTES', '+p_afegir_tasca_opcio_contacte');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('SELECTORCONTACTES', 'p_afegir_tasca_selector_contactes');
			
		}

	}
	
	//funcionalitat per afegir contactes usuari
	function borrar_tasca(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_tasca=$_REQUEST["id_tasca"];
		
		//borrem la tasca
		$delete_helper=new Delete_helper();
		$delete_helper->esborrar_tasca($id_usuari, $id_tasca);
		
		//redireccionem
		header('Location: index.php?tasca=tasca.llista_tasques&plantilla=tasca.p_llista_tasques');
		
	}
	
}
?>
