<?
/**
*    Codi clase B_usuari.php
*
*    @autor Jose Roig Torres
*
*    @tasca projecte de fi de carrera
*
*    @universitat Universitat Oberta de Catalunya
*
*    @area aplicacions web per treball col·laboratiu
*
*    @tema disseny i prototipatge d'un sistema d'esdeveniments per a dispositius mòbils de treball en grup
*/

include_once('libraries/php/db_connection.php');
include_once('src/integration/i_usuari.php');
include_once('src/integration/i_esdeveniment.php');
include_once('src/integration/i_usuari_usuari.php');
include_once('src/integration/i_tasca.php');
include_once('libraries/php/template_helper.php');

class B_usuari {
	
	//variable de nok template
	var $html;
	
	//constructor
	function B_usuari($html){
		$this->html=$html;
	}
	
	//funcionalitat de login_usuari
	function login_usuari(){
		
		//obtenim les variables necessaries
		$usuari=$_REQUEST['usuari'];
		$contrasena=$_REQUEST['contrasenya'];
		
		//busquem si lusuari sa autentificat correctament
		$connect=new Db_connection();
		$connect->connect();
		$connect->set_query("SELECT * FROM usuari WHERE contrasenya='".$contrasena."' AND usuari='".$usuari."'");
		$lista=$connect->get_object_list();
		if(count($lista)>=1){
			//lusuari existeix
			$autentificat="si";
		}else{
			//usuari no existeix
			$autentificat="no";
		}		
		
		//mirem si em de tornar a la pantalla de login o la de inici
		if($autentificat=="si"){
		
			//cream una sessio vinculada a l'usuari i carreguem les seves dades
			session_start();
			$us=new I_usuari();
			$us->carregar_dades_per_objecte_mysql($lista[0]);
			$_SESSION['id_usuari'] =  $us->id;
			
			//redireccionem a la plana dinici del usuari
			header('Location: index.php?tasca=usuari.inici_usuari&plantilla=usuari.p_inici_usuari');
		
		}else{
			
			//carreguem el missatge derror
			$this->html->asignar("MISSATGE_ERROR", "El nom d'usuari o clau no son correctes. Per favor torni a inserir-les.");
		
		}
		
	}
	
	//funcionalitat per logout dusuari
	function logout_usuari(){
		
		//borrem dades dautentificacio
		session_start();
		$_SESSION['id_usuari']="";
		
		//redireccionem a la plana dinici del usuari
		header('Location: index.php?');
		
	}
	
	//funcionalitat de inici_usuari
	function inici_usuari(){
		
		//	CARREGUEM DADES PRINCIPALS 
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$us=new I_usuari();
		$us->carregar_dades_per_id($_SESSION['id_usuari']);
		$this->html->asignar("USUARI", $us->usuari);
		$this->html->asignar("NOM", $us->nom);
		$this->html->asignar("LLINATGES", $us->llinatges);
		$this->html->asignar("EMAIL", $us->email);
		
		//obtenim la conexio a la base de dades
		$connect=new Db_connection();
		$connect->connect();
		
		//	CARREGUEM MISSATGES NOUS ///////////////////////////////////
		include('includes/php/nombre_missatges_nous.php');
		
		//	CARREGUEM CALENDARI///////////////////////////////////
		$nombre_casellas=35;
		//		preparem plantilla calendari
		$plantilla="p_calendari";
		$directori_plantilla="usuari/p_calendari.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		//		preparem dades
		if(isset($_REQUEST["mes"]) && isset($_REQUEST["any"])){
			$mes_actual=$_REQUEST["mes"];
			$any_actual=$_REQUEST["any"];
		}else{
			$mes_actual=date('m');
			$any_actual=date('Y');
		}
		//		asignem el mes i dia del calendari
		$this->html->asignar("MES_CALENDARI",$mes_actual);
		$this->html->asignar("ANY_CALENDARI",$any_actual);
		//		obtenim mes i anys anterior i seguent
		$data_aux=mktime(0,0,0,$mes_actual,1,$any_actual);
		$mes_any_anterior=strtotime('- 1 month',$data_aux);
		$mes_any_posterior=strtotime('+ 1 month',$data_aux);
		$this->html->asignar("MES_ANTERIOR",date('m', $mes_any_anterior));
		$this->html->asignar("ANY_ANTERIOR",date('Y', $mes_any_anterior));
		$this->html->asignar("MES_POSTERIOR",date('m', $mes_any_posterior));
		$this->html->asignar("ANY_POSTERIOR",date('Y', $mes_any_posterior));
		//		obtenim el nombre de dies del mes
		$aux_mes = mktime( 0, 0, 0, $mes_actual, 1, $any_actual ); 
		$dies_del_mes=date("t",$aux_mes);
		//		obtenim el index en el que ha de començar y acabar els dies del mes
		$ini_dies=(integer)(($nombre_casellas-$dies_del_mes)/2);
		$fi_dies=$ini_dies+$dies_del_mes+1;
		//		realitzem recorregut per les casellas del calendari
		$index=1;
		$data_aux=mktime(0,0,0,$mes_actual,1,$any_actual);
		$data_aux=strtotime('- '.$ini_dies.' day',$data_aux);
		while($index <= $nombre_casellas){
			$contingut_dia="";
			if($index<=$ini_dies){
				
				//dias anterioras al mes
				$this->html->asignar("NUMERO_DIA_".$index, (integer)date("d", $data_aux));
				
				//asignem l'enllaç del dia
				$this->html->asignar("LINK_DIA_".$index, "index.php?tasca=esdeveniment.llista_esdeveniments&plantilla=esdeveniment.p_llista_esdeveniments&dia=".date("d", $data_aux)."&mes=".date("m", $data_aux)."&any=".date("Y", $data_aux));

				//contingut
				include('includes/php/contingut_dia_calendari.php');

			}
			if($index>$ini_dies && $index<$fi_dies){
				
				//dies del mes
				$this->html->asignar("NUMERO_DIA_".$index,(integer)date("d", $data_aux));
				
				//asignem l'enllaç del dia
				$this->html->asignar("LINK_DIA_".$index, "index.php?tasca=esdeveniment.llista_esdeveniments&plantilla=esdeveniment.p_llista_esdeveniments&dia=".date("d", $data_aux)."&mes=".date("m", $data_aux)."&any=".date("Y", $data_aux));
				
				//contingut
				include('includes/php/contingut_dia_calendari.php');

			}
			if($index>=$fi_dies){
				
				//dies posteriros al mes
				$this->html->asignar("NUMERO_DIA_".$index,(integer)date("d", $data_aux));
				
				//asignem l'enllaç del dia
				$this->html->asignar("LINK_DIA_".$index, "index.php?tasca=esdeveniment.llista_esdeveniments&plantilla=esdeveniment.p_llista_esdeveniments&dia=".date("d", $data_aux)."&mes=".date("m", $data_aux)."&any=".date("Y", $data_aux));
				
				//contingut
				include('includes/php/contingut_dia_calendari.php');
				
			}
			//asignem el contingut del dia en cas de que n'hi hagi
			if($contingut_dia!=""){
				$this->html->asignar("CONTINGUT_DIA_".$index, $contingut_dia);
			}
			
			$index=$index+1;
			$data_aux=strtotime('+ 1 day',$data_aux);
		}
		
		//		asignem la plantilla a la seva posició
		$this->html->expandir('CALENDARI', 'p_calendari');

		//	CARREGUEM ESDEVENIMENTS NOUS
		
		//obtenim dades del selector
		$last_index=$_POST["last-events-index"];
		$valor_a_restar="";
		if($last_index=="1"){
			//1 dia
			$this->html->asignar('RECENT1', 'selected');
			$valor_a_restar="1";
		}else if($last_index=="2"){
			//1 setmana
			$this->html->asignar('RECENT2', 'selected');
			$valor_a_restar="7";
		}else if($last_index=="3"){
			//1 mes
			$this->html->asignar('RECENT3', 'selected');
			$valor_a_restar="30";
		}else{
			//1 setmana
			$valor_a_restar="7";
			$this->html->asignar('RECENT2', 'selected');
		}
		
		//	montem la query
		$mes_actual=date('m');
		$any_actual=date('Y');
		$dia_actual=date('d');
		$data_aux=mktime(0,0,0,$mes_actual,$dia_actual,$any_actual);
		
		$data_aux=strtotime('- '.$valor_a_restar.' day',$data_aux);
		$data_esdeveniments=date("Y-m-d", $data_aux);
		$query="SELECT * FROM 
		(
		   (SELECT esdeveniment.* FROM esdeveniment, esdeveniment_usuari WHERE esdeveniment_usuari.id_usuari='".$id_usuari."' AND esdeveniment.id=esdeveniment_usuari.id_esdeveniment)
		UNION ALL
		   (SELECT esdeveniment.* FROM esdeveniment, esdeveniment_grup, usuari_grup WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=esdeveniment_grup.id_grup AND esdeveniment.id=esdeveniment_grup.id_esdeveniment)
		UNION ALL
		   (
		      (SELECT esdeveniment.* FROM esdeveniment, esdeveniment_tasca, usuari_grup, tasca_grup WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=tasca_grup.id_grup AND tasca_grup.id_tasca=esdeveniment_tasca.id_tasca AND esdeveniment.id=esdeveniment_tasca.id_esdeveniment)
		   )
		 UNION
		   (
		   	   (SELECT esdeveniment.* FROM esdeveniment, esdeveniment_usuari WHERE esdeveniment_usuari.id_usuari='".$id_usuari."' AND esdeveniment.id=esdeveniment_usuari.id_esdeveniment)
		   )
		)
		AS tabla_resultado
		WHERE tabla_resultado.data_creacio>='".$data_esdeveniments."'
		ORDER BY tabla_resultado.data_creacio
		";
		
		//	obtenim els esdeveniments
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		
		//	preparem plantilla dels esdeveniments nous
		$plantilla="p_inici_usuari_taula_esdeveniments_nous";
		$directori_plantilla="usuari/p_inici_usuari_taula_esdeveniments_nous.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_inici_usuari_taula_esdeveniments_nous_fila', 'p_inici_usuari_taula_esdeveniments_nous');
		
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el esdeveniment
				$esdeveniment=new I_esdeveniment();
				$esdeveniment->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_ESDEVENIMENT_NOU', $esdeveniment->nom); 
				$this->html->asignar('ID_ESDEVENIMENT_NOU', $esdeveniment->id);
				$this->html->asignar('DATA_CREACIO_ESDEVENIMENT_NOU', $esdeveniment->data_creacio);
				$this->html->asignar('DATA_ESDEVENIMENT_NOU', $esdeveniment->data_esdeveniment);
				$this->html->asignar('DESCRIPCIO_ESDEVENIMENT_NOU', $esdeveniment->descripcio);
				
				//		obtenim el destinataris de l'esdeveniment
				include('includes/php/destinataris_esdeveniment.php');
				
				//			asignem destinataris de lesdeveniment
				$this->html->asignar('DESTINATARIS_ESDEVENIMENT_NOU', $destinataris);

				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES_ESDEVENIMENTS_NOUS', '+p_inici_usuari_taula_esdeveniments_nous_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('ESDEVENIMENTS_NOUS', 'p_inici_usuari_taula_esdeveniments_nous');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
		//	CARREGUEM ESDEVENIMENTS PROPERS ///////////////////////////////////
		
		//obtenim dades del selector
		$last_index=$_POST["future-events-index"];
		$valor_a_sumar="";
		if($last_index=="1"){
			//1 dia
			$this->html->asignar('PROPER1', 'selected');
			$valor_a_sumar="1";
		}else if($last_index=="2"){
			//1 setmana
			$this->html->asignar('PROPER2', 'selected');
			$valor_a_sumar="7";
		}else if($last_index=="3"){
			//1 mes
			$this->html->asignar('PROPER3', 'selected');
			$valor_a_sumar="30";
		}else{
			//1 setmana
			$valor_a_sumar="7";
			$this->html->asignar('PROPER2', 'selected');
		}
		
		//	montem la query
		$mes_actual=date('m');
		$any_actual=date('Y');
		$dia_actual=date('d');
		$data_aux=mktime(0,0,0,$mes_actual,$dia_actual,$any_actual);
		$data_inici_esdeveniments=date("Y-m-d", $data_aux);
		$data_aux=strtotime('+ '.$valor_a_sumar.' day',$data_aux);
		$data_fi_esdeveniments=date("Y-m-d", $data_aux);
		$query="SELECT * FROM 
		(
		   (SELECT esdeveniment.* FROM esdeveniment, esdeveniment_usuari WHERE esdeveniment_usuari.id_usuari='".$id_usuari."' AND esdeveniment.id=esdeveniment_usuari.id_esdeveniment)
		UNION ALL
		   (SELECT esdeveniment.* FROM esdeveniment, esdeveniment_grup, usuari_grup WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=esdeveniment_grup.id_grup AND esdeveniment.id=esdeveniment_grup.id_esdeveniment)
		UNION ALL
		   (
		      (SELECT esdeveniment.* FROM esdeveniment, esdeveniment_tasca, usuari_grup, tasca_grup WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=tasca_grup.id_grup AND tasca_grup.id_tasca=esdeveniment_tasca.id_tasca AND esdeveniment.id=esdeveniment_tasca.id_esdeveniment)
		   )
		 UNION
		   (
		   	   (SELECT esdeveniment.* FROM esdeveniment, esdeveniment_usuari WHERE esdeveniment_usuari.id_usuari='".$id_usuari."' AND esdeveniment.id=esdeveniment_usuari.id_esdeveniment)
		   )
		)
		AS tabla_resultado
		WHERE 
		tabla_resultado.data_esdeveniment>='".$data_inici_esdeveniments."' AND
		tabla_resultado.data_esdeveniment<='".$data_fi_esdeveniments."'
		";
		
		//	obtenim els esdeveniments
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		
		//	preparem plantilla dels esdeveniments nous
		$plantilla="p_inici_usuari_taula_esdeveniments_dia";
		$directori_plantilla="usuari/p_inici_usuari_taula_esdeveniments_dia.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_inici_usuari_taula_esdeveniments_dia_fila', 'p_inici_usuari_taula_esdeveniments_dia');
		
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el esdeveniment
				$esdeveniment=new I_esdeveniment();
				$esdeveniment->carregar_dades_per_id($llista[$index]->id);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_ESDEVENIMENT_DIA', $esdeveniment->nom); 
				$this->html->asignar('ID_ESDEVENIMENT_DIA', $esdeveniment->id);
				$this->html->asignar('DATA_CREACIO_ESDEVENIMENT_DIA', $esdeveniment->data_creacio);
				$this->html->asignar('DATA_ESDEVENIMENT_DIA', $esdeveniment->data_esdeveniment);
				$this->html->asignar('DESCRIPCIO_ESDEVENIMENT_DIA', $esdeveniment->descripcio);
				
				//		obtenim el destinataris de l'esdeveniment
				include('includes/php/destinataris_esdeveniment.php');
				
				//			asignem destinataris de lesdeveniment
				$this->html->asignar('DESTINATARIS_ESDEVENIMENT_DIA', $destinataris);

				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES_ESDEVENIMENTS_DIA', '+p_inici_usuari_taula_esdeveniments_dia_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('ESDEVENIMENTS_DIA', 'p_inici_usuari_taula_esdeveniments_dia');
			
		}else{
			//lista sin objetos, no mostramos nada
		}

		//CARREGUEM TASQUES QUE INICIEN EN AQUEST DIA
		
		//obtenim dades del selector
		$last_index=$_POST["future-ini-tasks-index"];
		$valor_a_sumar="";
		if($last_index=="1"){
			//1 dia
			$this->html->asignar('INICI1', 'selected');
			$valor_a_sumar="1";
		}else if($last_index=="2"){
			//1 setmana
			$this->html->asignar('INICI2', 'selected');
			$valor_a_sumar="7";
		}else if($last_index=="3"){
			//1 mes
			$this->html->asignar('INICI3', 'selected');
			$valor_a_sumar="30";
		}else{
			//1 setmana
			$valor_a_sumar="7";
			$this->html->asignar('INICI2', 'selected');
		}
		
		$mes_actual=date('m');
		$any_actual=date('Y');
		$dia_actual=date('d');
		$data_aux=mktime(0,0,0,$mes_actual,$dia_actual,$any_actual);
		$data_inici_tasques=date("Y-m-d", $data_aux);
		$data_aux=strtotime('+ '.$valor_a_sumar.' day',$data_aux);
		$data_fi_tasques=date("Y-m-d", $data_aux);
		
		//montem la query
		$query="(SELECT tasca.id FROM tasca, tasca_grup, usuari_grup, info_usuari_tasca WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=tasca_grup.id_grup AND tasca_grup.id_tasca=tasca.id AND tasca.data_inici>='".$data_inici_tasques."' AND tasca.data_inici<='".$data_fi_tasques."' AND info_usuari_tasca.id_tasca=tasca.id AND info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_estat!='1' GROUP BY tasca.id)
		UNION
		(SELECT tasca.id FROM tasca, tasca_usuari, info_usuari_tasca WHERE tasca_usuari.id_usuari='".$id_usuari."' AND tasca_usuari.id_tasca=tasca.id AND tasca.data_inici>='".$data_inici_tasques."' AND tasca.data_inici<='".$data_fi_tasques."' AND info_usuari_tasca.id_tasca=tasca.id AND info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_estat!='1' GROUP BY tasca.id)
		";
		
		//obtenim les tasques
		$connect->set_query($query);
		$llista=$connect->get_object_list();

		//insertem dades en el template
		//	preparem les plantilles interiors
		$plantilla="p_inici_usuari_taula_tasques_inici";
		$directori_plantilla="usuari/p_inici_usuari_taula_tasques_inici.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_inici_usuari_taula_tasques_inici_fila', 'p_inici_usuari_taula_tasques_inici');
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim la tasca
				$tasca=new I_tasca();
				$tasca->carregar_dades_per_id($llista[$index]->id);
				
				//borrem variables pk no hi hagi duplicidad de variables
				$this->html->limpiar("MISSATGES_NOUS_TASQUES_LLISTA_TASQUES_INICI");
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_TASQUES_INICI', $tasca->nom); 
				$this->html->asignar('ID_TASCA_TASQUES_INICI', $tasca->id); 
				//		asignam el nombre de missatges no llegits de la fila actual
				$query="SELECT COUNT(DISTINCT llegit.id_missatge) AS nombre FROM llegit, missatge WHERE llegit.id_usuari='".$id_usuari."' AND llegit.id_missatge=missatge.id AND missatge.id_tasca='".$tasca->id."'";
				$connect->set_query($query);
				$llista_aux=$connect->get_object_list();
				if($llista_aux[0]->nombre!=0){
					$this->html->asignar("MISSATGES_NOUS_TASQUES_LLISTA_TASQUES_INICI","<span class='missatges_no_llegits'>".$llista_aux[0]->nombre."</span>");
				}
				
				// Asignem l'estat de la tasca
				$query="SELECT estat.nom FROM estat, info_usuari_tasca WHERE info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_tasca='".$tasca->id."' AND info_usuari_tasca.id_estat=estat.id";
				$connect->set_query($query);
				$llista_aux=$connect->get_object_list();
				$this->html->asignar('ESTAT_TASQUES_INICI', $llista_aux[0]->nom); 
				
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES_TASQUES_INICI', '+p_inici_usuari_taula_tasques_inici_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('TASQUES_INICI', 'p_inici_usuari_taula_tasques_inici');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
		//CARREGUEM TASQUES QUE FINALITCEN EN AQUEST DIA
		
		//obtenim dades del selector
		$last_index=$_POST["future-fin-tasks-index"];
		$valor_a_sumar="";
		if($last_index=="1"){
			//1 dia
			$this->html->asignar('FI1', 'selected');
			$valor_a_sumar="1";
		}else if($last_index=="2"){
			//1 setmana
			$this->html->asignar('FI2', 'selected');
			$valor_a_sumar="7";
		}else if($last_index=="3"){
			//1 mes
			$this->html->asignar('FI3', 'selected');
			$valor_a_sumar="30";
		}else{
			//1 setmana
			$valor_a_sumar="7";
			$this->html->asignar('FI2', 'selected');
		}
		
		$mes_actual=date('m');
		$any_actual=date('Y');
		$dia_actual=date('d');
		$data_aux=mktime(0,0,0,$mes_actual,$dia_actual,$any_actual);
		$data_inici_tasques=date("Y-m-d", $data_aux);
		$data_aux=strtotime('+ '.$valor_a_sumar.' day',$data_aux);
		$data_fi_tasques=date("Y-m-d", $data_aux);
		
		//montem la query
		$query="(SELECT tasca.id FROM tasca, tasca_grup, usuari_grup, info_usuari_tasca WHERE usuari_grup.id_usuari='".$id_usuari."' AND usuari_grup.id_grup=tasca_grup.id_grup AND tasca_grup.id_tasca=tasca.id AND tasca.data_fi>='".$data_inici_tasques."' AND tasca.data_fi<='".$data_fi_tasques."' AND info_usuari_tasca.id_tasca=tasca.id AND info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_estat!='1' GROUP BY tasca.id)
		UNION
		(SELECT tasca.id FROM tasca, tasca_usuari, info_usuari_tasca WHERE tasca_usuari.id_usuari='".$id_usuari."' AND tasca_usuari.id_tasca=tasca.id AND tasca.data_fi<='".$data_inici_tasques."' AND tasca.data_fi>='".$data_fi_tasques."' AND info_usuari_tasca.id_tasca=tasca.id AND info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_estat!='1' GROUP BY tasca.id)
		";
		
		//obtenim les tasques
		$connect->set_query($query);
		$llista=$connect->get_object_list();

		//insertem dades en el template
		//	preparem les plantilles interiors
		$plantilla="p_inici_usuari_taula_tasques_fi";
		$directori_plantilla="usuari/p_inici_usuari_taula_tasques_fi.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_inici_usuari_taula_tasques_fi_fila', 'p_inici_usuari_taula_tasques_fi');
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				
				// Obtenim el grup
				$tasca=new I_tasca();
				$tasca->carregar_dades_per_id($llista[$index]->id);
				
				//borrem variables pk no hi hagi duplicidad de variables
				$this->html->limpiar("MISSATGES_NOUS_TASQUES_LLISTA_TASQUES_FI");
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM_TASQUES_FI', $tasca->nom); 
				$this->html->asignar('ID_TASCA_TASQUES_FI', $tasca->id); 
				//		asignam el nombre de missatges no llegits de la fila actual
				$query="SELECT COUNT(DISTINCT llegit.id_missatge) AS nombre FROM llegit, missatge WHERE llegit.id_usuari='".$id_usuari."' AND llegit.id_missatge=missatge.id AND missatge.id_tasca='".$tasca->id."'";
				$connect->set_query($query);
				$llista_aux=$connect->get_object_list();
				if($llista_aux[0]->nombre!=0){
					$this->html->asignar("MISSATGES_NOUS_TASQUES_LLISTA_TASQUES_FI","<span class='missatges_no_llegits'>".$llista_aux[0]->nombre."</span>");
				}
				
				// Asignem l'estat de la tasca
				$query="SELECT estat.nom FROM estat, info_usuari_tasca WHERE info_usuari_tasca.id_usuari='".$id_usuari."' AND info_usuari_tasca.id_tasca='".$tasca->id."' AND info_usuari_tasca.id_estat=estat.id";
				$connect->set_query($query);
				$llista_aux=$connect->get_object_list();
				$this->html->asignar('ESTAT_TASQUES_FI', $llista_aux[0]->nom); 
				
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES_TASQUES_FI', '+p_inici_usuari_taula_tasques_fi_fila');
				}
				
				$index=$index+1;
			}
			$this->html->expandir('TASQUES_FI', 'p_inici_usuari_taula_tasques_fi');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
	}
	
	//funcionalitat de inici_usuari
	function registre_usuari(){
		
		//creem linstancia dusuari
		$usuari=new I_usuari();
		
		//obtenim dades per post
		$usuari->nom=$_POST["nom"];
		$usuari->llinatges=$_POST["llinatges"];
		$usuari->email=$_POST["email"];
		$usuari->usuari=$_POST["usuari"];
		$usuari->contrasenya=$_POST["contrasenya"];
		
		//guardem dades
		$usuari->guardar_dades();
		
		//redireccionem a la plana de login
		header('Location: index.php');
		
	}
	
	//funcionalitat per vorer els contactes de lusuari actual
	function contactes_usuari(){
		
		//obtenim els parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_contacte=$_REQUEST['id_contacte'];
		
		//monetem la query
		$query="SELECT * FROM usuari_usuari WHERE id_usuari_principal='".$id_usuari."'";
		
		//obtenim els contactes
		$connect=new Db_connection();
		$connect->connect();
		$connect->set_query($query);
		$llista=$connect->get_object_list();

		//insertem dades en el template
		//	preparem les plantilles interiors
		$plantilla="p_contactes_usuari_taula";
		$directori_plantilla="usuari/p_contactes_usuari_taula.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_contactes_usuari_fila', 'p_contactes_usuari_taula');
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				// Obtenim lusuari actual
				$usuari=new I_usuari();
				$usuari->carregar_dades_per_id($llista[$index]->id_usuari_contacte);
				
				// Asignam valors a la fila actual
				$this->html->asignar('NOM', $usuari->nom); 
				$this->html->asignar('LLINATGES', $usuari->llinatges);
				$this->html->asignar('EMAIL', $usuari->email);  
				$this->html->asignar('ID_CONTACTE', $usuari->id);
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES', '+p_contactes_usuari_fila');
				}
				$index=$index+1;
			}
			$this->html->expandir('TAULA', 'p_contactes_usuari_taula');
			
		}else{
			//lista sin objetos, no mostramos nada
		}
		
	}
	
	//funcionalitat per afegir contactes usuari
	function afegir_contacte_usuari(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_contacte=$_REQUEST["id_contacte"];
		
		//inserim nou contacte
		$us_us=new I_usuari_usuari();
		$us_us->id_usuari_principal=$id_usuari;
		$us_us->id_usuari_contacte=$id_contacte;
		$us_us->guardar_dades();
		
		//redireccionem
		header('Location: index.php?tasca=usuari.contactes_usuari&plantilla=usuari.p_contactes_usuari');
		
	}
	
	//funcionalitat per afegir contactes usuari
	function borrar_contacte_usuari(){
		
		//obtenim conexion a la base de dades
		$connect=new Db_connection();
		$connect->connect();
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		$id_contacte=$_REQUEST['id_contacte'];
		
		//borrem esdeveniments entre els usuaris
		//	obtenim els esdeveniments entre els dos usuaris
		$query="SELECT esdeveniment.id FROM esdeveniment, esdeveniment_usuari WHERE esdeveniment.id_usuari='".$id_usuari."' AND esdeveniment.id=esdeveniment_usuari.id_esdeveniment AND esdeveniment_usuari.id_usuari='".$id_contacte."'
		UNION
		SELECT esdeveniment.id FROM esdeveniment, esdeveniment_usuari WHERE esdeveniment.id_usuari='".$id_contacte."' AND esdeveniment.id=esdeveniment_usuari.id_esdeveniment AND esdeveniment_usuari.id_usuari='".$id_usuari."'
		";
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		//	borrem les entrades de esdeveniment i esdeveniment_usuari corresponents
		if(sizeof($llista)>0){
			
			//borrem les entrades desdeveniment
			$query="DELETE FROM esdeveniment WHERE esdeveniment.id='".$llista_aux[0]->id."'";
			$connect->set_query($query);
			
			//borrem les entrades desdeveniment_usuari
			$query="DELETE FROM esdeveniment_usuari WHERE esdeveniment_usuari.id_esdeveniment='".$llista_aux[0]->id."'";
			$connect->set_query($query);
			
			$index=$index+1;
		}
		
		//borrem missatges entre els usuaris
		$query="DELETE FROM missatge WHERE missatge.id_usuari_receptor='".$id_usuari."' AND missatge.id_usuari_emisor='".$id_contacte."'";
		$connect->set_query($query);
		$query="DELETE FROM missatge WHERE missatge.id_usuari_receptor='".$id_contacte."' AND missatge.id_usuari_emisor='".$id_usuari."'";
		$connect->set_query($query);
		
		//borrem entrades de la taula usuari_usuari
		$query="DELETE FROM usuari_usuari WHERE id_usuari_principal='".$id_usuari."' AND id_usuari_contacte='".$id_contacte."'";
		$connect->set_query($query);
		
		//redireccionem
		header('Location: index.php?tasca=usuari.contactes_usuari&plantilla=usuari.p_contactes_usuari');
		
	}
	
	//funcionalitat per buscar usuaris
	function cercar_usuari(){
		
		//obtenim conexion a la base de dades
		$connect=new Db_connection();
		$connect->connect();
		
		//obtenim els parametres de cerca
		$nom=$_POST["nom"];
		$llinatges=$_POST["llinatges"];
		$usuari=$_POST["usuari"];
		$email=$_POST["email"];
		
		//carreguem missatges nous
		include('includes/php/nombre_missatges_nous.php');
		
		//construim la consulta
		$where="WHERE";
		if($nom!=""){
			$where=$where." nom LIKE '%".$nom."%'";
		}
		if($llinatges!=""){
			if($where!="WHERE"){
				$where=$where." AND llinatges LIKE '%".$llinatges."%'";
			}else{
				$where=$where." llinatges LIKE '%".$llinatges."%'";
			}
		}
		if($usuari!=""){
			if($where!="WHERE"){
				$where=$where." AND usuari LIKE '%".$usuari."%'";
			}else{
				$where=$where." usuari LIKE '%".$usuari."%'";
			}
		}
		if($email!=""){
			if($where!="WHERE"){
				$where=$where." AND email LIKE '%".$email."%'";
			}else{
				$where=$where." email LIKE '%".$email."%'";
			}
		}
		
		if($where!="WHERE"){
			$query="SELECT * FROM usuari ".$where;
		}else{
			$query="SELECT * FROM usuari ";
		}
		
		//busquem els usuaris segons el criteris de cerca
		if($query!="SELECT * FROM usuari "){
			$connect->set_query($query);
			$llista=$connect->get_object_list();
		}

		//insertem dades en el template
		//	preparem les plantilles interiors
		$plantilla="p_cercar_usuari_taula";
		$directori_plantilla="usuari/p_cercar_usuari_taula.html";
		$this->html->cargar($plantilla,$directori_plantilla);
		$this->html->definirBloque('p_cercar_usuari_fila', 'p_cercar_usuari_taula');
		//	recorrem array de dades per inserirles
		if(sizeof($llista)>0){
			
			$index=0;
			while($index < sizeof($llista)){
				// Asignam valors a la fila actual
				$this->html->asignar('NOM', $llista[$index]->nom); 
				$this->html->asignar('LLINATGES', $llista[$index]->llinatges);
				$this->html->asignar('EMAIL', $llista[$index]->email);  
				$this->html->asignar('ID_CONTACTE', $llista[$index]->id);
				// Expandim la fila actual
				if($index!=(sizeof($llista)-1)){
					$this->html->expandir('FILES', '+p_cercar_usuari_fila');
				}
				$index=$index+1;
			}
			$this->html->expandir('TAULA', 'p_cercar_usuari_taula');
			
		}else{
			//lista sin objetos, no mostramos nada
		}

	}
	
	//funcionalitat carregar les dades d ela pantalla de editar dades usuari
	function dades_editar_dades_usuari(){
		
		//obtenim conexion a la base de dades
		$connect=new Db_connection();
		$connect->connect();
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
	
		//carreguem missatges nous
		include('includes/php/nombre_missatges_nous.php');
	
		//obtenim le dades del usuari actual
		$query="SELECT usuari.* FROM usuari WHERE usuari.id='".$id_usuari."'";
		$connect->set_query($query);
		$llista=$connect->get_object_list();
		
		//asignem dades
		$this->html->asignar('NOM', $llista[0]->nom); 
		$this->html->asignar('LLINATGES', $llista[0]->llinatges); 
		$this->html->asignar('EMAIL', $llista[0]->email); 
		
	}
	
	//funcionalitat per editar les dades d'un usuari
	function editar_dades_usuari(){
		
		//obtenim parametres
		session_start();
		$id_usuari=$_SESSION['id_usuari'];
		
		//obtenim lobjecte dusuari
		$usuari=new I_usuari();
		$usuari->carregar_dades_per_id($id_usuari);
		
		//guardem les dades noves
		$usuari->nom=$_REQUEST["nom"];
		$usuari->llinatges=$_REQUEST["llinatges"];
		$usuari->email=$_REQUEST["email"];
		$usuari->guardar_dades();
		
		//redireccionem
		header('Location: index.php?tasca=usuari.inici_usuari&plantilla=usuari.p_inici_usuari');
		
	}
	
}
?>
